// ------------------------- * Meters * -------------------------
function meterSetConstants(eId, tm)
{
	host.sendNestCmsg(host.sprintf("mM%03u", eId), {id:'WRIN', dTM01: tm[0], dTM02: tm[1]});
}

// ------------------------- * Labels * -------------------------
function GUI_createMeterLabel(frm, x, y, label, surround)
{
	var l={};

	if(cfg_fusionUI)
	{
		if(surround)
		{
			l.bg =gui.newPicture(frm,  x, y, 296, 26, "img/svg/meter_label_surr_bg.svg");
			l.lbl=gui.newLabel  (l.bg, 0, 3, 296, 20, '', {font:fontRegular(12), color:color.lgray, align:gui.CENTER, valign:gui.MIDDLE});
		}
		else
		{
			l.bg =gui.newPicture(frm,  x, y, 142, 26, "img/svg/meter_label_bg.svg");
			l.lbl=gui.newLabel  (l.bg, 0, 3, 142, 20, '', {font:fontRegular(12), color:color.lgray, align:gui.CENTER, valign:gui.MIDDLE});
		}
		l.bg.setActive=function(on) {}; // Does Nothing
	}
	else
	{
		l.bg =gui.newPicture(frm,  x, y, 62, 17, "img/mtr_lbl.png");
		l.lbl=gui.newLabel  (l.bg, 3, 2, 55, 13, '', {font:"myriad-roman-10", color:color.labelOFF, align:gui.CENTER});
		l.bg.setActive=function(on) {this.setIndex(on?1:0);};
	}
	l.lbl.setText(label);
	l.label=label;
	l.active=false;
	l.custom=false;
	l.update=function()
	{
		if(l.custom || l.active)
		{
			this.bg.setActive(true);
			this.lbl.setProp('color', color.labelON);
		}
		else
		{
			this.bg.setActive(false);
			this.lbl.setProp('color', color.labelOFF);
		}
	};
	l.activate=function(on)
	{
		if(this.active==on) return;

		this.active=on;
		this.update();
	};
	l.setText=function(t)
	{
		if(t==null)
		{
			this.lbl.setText(this.label);
			if(this.custom)
			{
				this.custom=false;
				this.update();
			}
		}
		else
		{
			this.lbl.setText(t);
			if(!this.custom)
			{
				this.custom=true;
				this.update();
			}
		}
	};

	return l;
}
function createFakeMeterLabel()
{
	return {activate:function(on){},setText:function(t){}};
}
function getMeterTitle(id)
{
// TODO: use actually selected source here, not a predefined text
	switch(id)
	{
	case mtrEng.main1: return "Program 1";
	case mtrEng.main2: return "Program 2";
	case mtrEng.main3: return "Program 3";
	case mtrEng.main4: return "Program 4";
	case mtrEng.main5: return "Preview";
	case mtrEng.main6: return "Monitor";
	}
	return "";
}

// ------------------------- * Meters * -------------------------
const mtrNumBars=91;
const mtrPoints=[-500, 0, -100, 81, 0, 91];

function createSurroundMeter(frm, guiId, engId)
{
	var mposx=[27, 50, 108, 131, 154, 177, 200, 223];
	var mp, barr=[];
	var n;

	mp=gui.newPicture(frm, 45, 12, 52, 19, "img/mtr_peak.png");
	for(n=0; n<8; n++)
	{
		barr[n]=gui.newMeterEx(frm, mposx[n]-17, 42, 17, 364, "img/mbar_ex.png");
		barr[n].setPoints(mtrPoints); barr[n].setCPoint(60);
	}
	gui.createMeter(guiId, 4, mp, barr);
	gui.linkMeter(guiId, engId);
	host.requestMeter(engId, true);
	meterSetConstants(engId, [65000, 65000]); // Request VU metering
}

function createVUlabels(frm, dx)
{
	const w=18; //label width
	const h=12; //label height
	const x=122/2-w/2+dx;
	const y=5;
	const dy=50; //delta height  plus adjustments
	const db={
		"0": [x, y],
		"10": [x, y+dy*1],
		"20": [x, y+dy*2],
		"25": [x, y+dy*3],
		"30": [x, y+dy*4],
		"35": [x, y+dy*5],
		"40": [x, y+dy*6],
		"45": [x, y+dy*7],
		"50": [x, y+dy*8],
		"55": [x, y+dy*9],
		"60": [x, y+dy*10-5] //design pdf had 9.5 units but Element design has more
	};

	var i, lbl, mark;
	for(mark in db)
	{
		lbl=gui.newLabel(frm, db[mark][0], db[mark][1], w, h, '', prop.meter_scale);
		lbl.setText(mark);
	}
}

function createEBUDlabels(frm, dx)
{
	const w=24; //label width
	const h=12; //label height
	const x=122/2-w/2+dx;
	const y=0;
	const dy=75; //dy and dy2 calculated from original Element partitions for EBUD
	const dy2=50;

	const db={
		" 0 ": [x, y],
		"-5": [x, y+dy*1],
		"-10": [x, y+dy*2],
		"-15": [x, y+dy*3],
		"-20": [x, y+dy*4],
		"-25": [x, y+dy*4+dy2*1],
		"-30": [x, y+dy*4+dy2*2],
		"-40": [x, y+dy*4+dy2*3],
		"-60": [x, y+dy*4+dy2*4-5] //TODO why do we have to adjust -60 a few px ?
	};
	var lbl, mark;
	for(mark in db)
	{
		lbl=gui.newLabel(frm, db[mark][0], db[mark][1], w, h, '', prop.meter_scale);
		lbl.setText(mark);
	}
}

function createDINlabels(frm, dx)
{
	const w=24; //label width
	const h=12; //label height
	const x=122/2-w/2+dx;
	const y=0;
	const dy=75; //dy and dy2 calculated from original Element partitions for EBUD
	const dy2=50;

	const db={
		" 5" : [x, y],
		" 0 ": [x, y+dy*1],
		"-5" : [x, y+dy*2],
		"-10": [x, y+dy*2+dy2*1],
		"-15": [x, y+dy*2+dy2*2],
		"-20": [x, y+dy*2+dy2*3],
		"-25": [x, y+dy*2+dy2*4],
		"-30": [x, y+dy*2+dy2*5],
		"-40": [x, y+dy*2+dy2*6],
		"-60": [x, y+dy*2+dy2*7-5]
	};
	var lbl, mark;
	for(mark in db)
	{
		lbl=gui.newLabel(frm, db[mark][0], db[mark][1], w, h, '', prop.meter_scale);
		lbl.setText(mark);
	}
}

function createBBClabels(frm, dx)
{
	const w=20; //label width
	const h=12; //label height
	const x=122/2-20/2+dx;
	const y=20;
	const dy=75;

	const db={
		"7": [x, y],
		"6": [x, y+dy*1],
		"5": [x, y+dy*2],
		"4": [x, y+dy*3],
		"3": [x, y+dy*4],
		"2": [x, y+dy*5],
		"1": [x, y+dy*6]
	};
	var lbl, mark;
	for(mark in db)
	{
		lbl=gui.newLabel(frm, db[mark][0], db[mark][1], w, h, '', prop.meter_scale);
		lbl.setText(mark);
	}
}

function createNordiclabels(frm, dx)
{
	const w=26; //label width
	const h=12; //label height
	const x=122/2-w/2+dx;
	const y=0;
	const dy=55;
	const dy2=30;

	const db={
		"+12": [x, y, w],
		"+6":  [x, y+dy*1, w],
		"TEST":[x-6/2, y+dy*2, w+6],
		"-6":  [x, y+dy*3, w],
		"-12": [x, y+dy*4, w],
		"-18": [x, y+dy*5, w],
		"-24": [x, y+dy*6, w],
		"-30": [x, y+dy*7, w],
		"-36": [x, y+dy*8, w],
		"-42": [x, y+dy*8+dy2, w]
	};
	var lbl, mark;
	for(mark in db)
	{
		lbl=gui.newLabel(frm, db[mark][0], db[mark][1], db[mark][2], h, '', prop.meter_scale);
		lbl.setText(mark);
	}
}

function meter_getTimeConstants(type)
{
	switch(type)
	{
	case "VU":     return [65000, 65000];
	case "EBUD":   return [1255, 738000];
	case "DIN":    return [1700, 650000];
	case "NORDIC": return [1700, 650000];
	case "BBC":    return [2483, 1013000];
	}
	return [0, 0];
}

function createMultiMeter(frm, x, guiId, engId, type)
{
	var meter={};
	var scale, m=[];
	var n;

	switch(type)
	{
	default:
	case "VU":
		meter.frame=gui.newFrame(frm, x, 37, 102, 400, "img/mtr_scale_vu.png");
		meter.peak =gui.newPicture(frm, x+18, 37-16, 67, 7, "img/mtr_ovr.png");
		for(n=0; n<2; n++)
		{
			m[n]=gui.newMeterEx(meter.frame, 18+50*n, 2, 17, 396, "img/mbar_ex.png");
			m[n].setPoints([-600, 0, -500, 9, -100, 89, 0, 99]);
			m[n].setCPoint(68);
		}
		break;
	case "EBUD":
		meter.frame=gui.newFrame(frm, x+13, 37, 77, 400, "img/mtr_scale_ebud.png");
		meter.peak =gui.newPicture(frm, x+18, 37-16, 67, 7, "img/mtr_ovr.png");
		for(n=0; n<2; n++)
		{
			m[n]=gui.newMeterEx(meter.frame, 18-13+50*n, 2, 17, 396, "img/mbar_ex.png");
			m[n].setPoints([-600, 0, -400, 9, -300, 19, -200, 39, -50, 84, 0, 99]);
			m[n].setCPoint(71);
		}
		break;
	case "DIN":
		meter.frame=gui.newFrame(frm, x+13, 37, 76, 400, "img/mtr_scale_din.png");
		meter.peak =gui.newPicture(frm, x+18, 37-16, 67, 7, "img/mtr_ovr.png");
		for(n=0; n<2; n++)
		{
			m[n]=gui.newMeterEx(meter.frame, 18-13+50*n, 2, 17, 396, "img/mbar_ex.png");
			m[n].setPoints([-600-90, 0, -400-90, 9, -300-90, 19, -50-90, 69, 50-90, 99]);
			m[n].setCPoint(84);
		}
		break;
	case "NORDIC":
		meter.frame=gui.newFrame(frm, x+13-1, 37+2-18, 78, 419, "img/mtr_scale_nord.png");
		meter.peak =gui.newPicture(frm, x+18, 37-16-10, 67, 7, "img/mtr_ovr.png");
		for(n=0; n<2; n++)
		{
			m[n]=gui.newMeterEx(meter.frame, 18-13+51*n, 2, 17, 416, "img/mbar_ex.png");
			m[n].setPoints([-420-180, 0, -360-180, 8, 120-180, 104]);
			m[n].setCPoint(92);
		}
		break;
	case "BBC":
		meter.frame=gui.newFrame(frm, x+13-1, 37, 78, 398, "img/mtr_scale_bbc.png");
		meter.peak =gui.newPicture(frm, x+18, 37-16, 67, 7, "img/mtr_ovr.png");
		for(n=0; n<2; n++)
		{
			m[n]=gui.newMeterEx(meter.frame, 18-13+51*n, 2, 17, 396, "img/mbar_ex.png");
			m[n].setPoints([-200-180, 0, -120-180, 15, 120-180, 99]);
			m[n].setCPoint(87);
		}
		break;
	}
	gui.createMeter(guiId, 4, meter.peak, m);
	gui.linkMeter(guiId, engId);
	host.requestMeter(engId, true);
	meterSetConstants(engId, meter_getTimeConstants(type));

	meter.parent=frm;
	meter.x=x;
	meter.guiId=guiId;
	meter.engId=engId;
	meter.type=type;
	meter.surround=false;
	meter.destroy=function()
	{
	//gui.deleteMeter(this.guiId);
		host.requestMeter(this.engId, false);
		this.frame.destroy();
		this.peak.destroy();
	}
	meter.create=createMultiMeter;
	return meter;
}

function createPhaseMeter(frm, x, y)
{
	var phase;

	//phase=gui.newLabel(frm, x, y, 121, 12, "", {font:fontRegular(10), color:gui.rgb(255,255,255), align:gui.CENTER, valign:gui.MIDDLE});
	phase=gui.newMeterPh (frm, x+18, y, 85, 8, "img/svg/mbar_phc.svg");
	phase.l0=gui.newLabel(frm, x   , y, 12, 8, '', prop.meter_scale); phase.l0.setText("-1");
	phase.l1=gui.newLabel(frm, x+18+85+6, y, 12, 8, '', prop.meter_scale); phase.l1.setText("+1");
	return phase;
}

function createFusionMultiMeter(frm, x, guiId, engId, type)
{
	var meter={};
	var scale, m=[], ml, mr;
	var n;

	meter.frame=gui.newFrame(frm, x, 32+12, 142, 552, "img/svg/meter_bg.svg");
	meter.peak=gui.newLabel(frm, x, 0, 142, 32, "img/svg/meter_peak_label_bg.svg", {font:fontRegular(18), color:gui.rgb(86,86,86), acolor:gui.rgb(35,36,38), align:gui.CENTER, valign:gui.MIDDLE});
	meter.peak.setText("PEAK");

	meter.phase=createPhaseMeter(meter.frame, 10, 6);

	switch(type)
	{
	default:
	case "VU":
		scale=gui.newFrame(meter.frame, 142/2-122/2, 552/2-520/2, 122, 520, "img/svg/mtr_scale_vu.svg");
		createVUlabels(scale, 0);
		for(n=0; n<2; n++)
		{
			m[n]=gui.newMeterEx(scale, 20+60*n, 10, 22, 500, "img/svg/mbar_ex_h5.svg");
			m[n].setPoints([-600, 0, -550, 10, -200, 80, 0, 100]);
			m[n].setCPoint(77);
		}
		break;
	case "EBUD":
		scale=gui.newFrame(meter.frame, 142/2-122/2, 552/2-505/2, 122, 505, "img/svg/mtr_scale_ebud.svg");
		createEBUDlabels(scale, 0);
		for(n=0; n<2; n++)
		{
			m[n]=gui.newMeterEx(scale, 20+60*n, 5, 22, 500, "img/svg/mbar_ex_h5.svg");
			m[n].setPoints([-600, 0, -400, 10, -300, 20, -200, 40, -50, 85, 0, 100]);
			m[n].setCPoint(72);
		}
		break;
	case "DIN":
		scale=gui.newFrame(meter.frame, 142/2-122/2, 552/2-505/2, 122, 505, "img/svg/mtr_scale_din.svg");
		createDINlabels(scale, 0);
		for(n=0; n<2; n++)
		{
			m[n]=gui.newMeterEx(scale, 20+60*n, 5, 22, 500, "img/svg/mbar_ex_h5.svg");
			m[n].setPoints([-600-90, 0, -400-90, 10, -300-90, 20, -50-90, 70, 50-90, 100]);
			m[n].setCPoint(85);
		}
		break;
	case "NORDIC":
		scale=gui.newFrame(meter.frame, 142/2-122/2, 552/2-480/2, 122, 480, "img/svg/mtr_scale_nordic.svg");
		createNordiclabels(scale, 0);
		for(n=0; n<2; n++)
		{
			m[n]=gui.newMeterEx(scale, 20+60*n, 5, 22, 475, "img/svg/mbar_ex_h5.svg");
			m[n].setPoints([-420-180, 0, -360-180, 7, 120-180, 95]); //old mtr had linear from 8 to 104 with cl at 92, so had to find gcd for (104-8) and (92-8) which is 12, so it went down to 11 here
			m[n].setCPoint(84);
		}
		break;
	case "BBC":
		scale=gui.newFrame(meter.frame, 142/2-122/2, 552/2-500/2, 122, 500, "img/svg/mtr_scale_bbc.svg");
		createBBClabels(scale, 0);
		for(n=0; n<2; n++)
		{
			m[n]=gui.newMeterEx(scale, 20+60*n, 5, 22, 500, "img/svg/mbar_ex_h5.svg");
			m[n].setPoints([-200-180, 0, -120-180, 5, 120-180, 95, 150-180, 100]);
			m[n].setCPoint(83);
		}
		break;
	}
	gui.createMeter(guiId, 4, meter.peak, m, meter.phase);
	gui.linkMeter(guiId, engId);
	host.requestMeter(engId, true);
	meterSetConstants(engId, meter_getTimeConstants(type));

	meter.parent=frm;
	meter.x=x;
	meter.guiId=guiId;
	meter.engId=engId;
	meter.type=type;
	meter.surround=false;
	meter.destroy=function()
	{
	//gui.deleteMeter(this.guiId);
		host.requestMeter(this.engId, false);
		this.frame.destroy();
		this.peak.destroy();
	}
	meter.create=createFusionMultiMeter;
	return meter;
}

function createFusionSurroundMultiMeter(frm, x, guiId, engId, type)
{
	var meter={};
	var scale, m=[], l;
	var n;
	const lt=["L","R","LF","RF","C","LS","RS","LFE"];

	meter.frame=gui.newFrame(frm, x, 32+12, 296, 552, "img/svg/meter_bg_surr.svg");
	meter.peak=gui.newLabel(frm, x, 0, 142, 32, "img/svg/meter_peak_label_bg.svg", {font:fontRegular(18), color:gui.rgb(86,86,86), acolor:gui.rgb(35,36,38), align:gui.CENTER, valign:gui.MIDDLE})
	meter.peak.setText("PEAK");

	for(n=0; n<8; n++)
	{
		l=gui.newLabel(meter.frame, 5+20+(n>1)*33+27*n, 552-16, 22, 12, '', prop.meter_scale);
		l.setText(lt[n]);
	}
	meter.phase=createPhaseMeter(meter.frame, 33, 6);
	switch(type)
	{
	default:
	case "VU":
		scale=gui.newFrame(meter.frame, 5, 552/2-520/2, 286, 520, "img/svg/mtr_scale_surr_vu.svg");
		createVUlabels(scale, 27);
		for(n=0; n<8; n++)
		{
			m[n]=gui.newMeterEx(scale, 20+(n>1)*33+27*n, 10, 22, 500, "img/svg/mbar_ex_h5.svg");
			m[n].setPoints([-600, 0, -550, 10, -200, 80, 0, 100]);
			m[n].setCPoint(77);
		}
		break;
	case "EBUD":
		scale=gui.newFrame(meter.frame, 5, 552/2-505/2, 286, 505, "img/svg/mtr_scale_surr_ebud.svg");
		createEBUDlabels(scale, 27);
		for(n=0; n<8; n++)
		{
			m[n]=gui.newMeterEx(scale, 20+(n>1)*33+27*n, 5, 22, 500, "img/svg/mbar_ex_h5.svg");
			m[n].setPoints([-600, 0, -400, 10, -300, 20, -200, 40, -50, 85, 0, 100]);
			m[n].setCPoint(72);
		}
		break;
	case "DIN":
		scale=gui.newFrame(meter.frame, 5, 552/2-505/2, 286, 505, "img/svg/mtr_scale_surr_din.svg");
		createDINlabels(scale, 27);
		for(n=0; n<8; n++)
		{
			m[n]=gui.newMeterEx(scale, 20+(n>1)*33+27*n, 5, 22, 500, "img/svg/mbar_ex_h5.svg");
			m[n].setPoints([-600-90, 0, -400-90, 10, -300-90, 20, -50-90, 70, 50-90, 100]);
			m[n].setCPoint(85);
		}
		break;
	case "NORDIC":
		scale=gui.newFrame(meter.frame, 5, 552/2-480/2, 286, 480, "img/svg/mtr_scale_surr_nordic.svg");
		createNordiclabels(scale, 27);
		for(n=0; n<8; n++)
		{
			m[n]=gui.newMeterEx(scale, 20+(n>1)*33+27*n, 5, 22, 475, "img/svg/mbar_ex_h5.svg");
			m[n].setPoints([-420-180, 0, -360-180, 7, 120-180, 95]); // old mtr had linear from 8 to 104 with cl at 92, so had to find gcd for (104-8) and (92-8) which is 12, so it went down to 11 here
			m[n].setCPoint(84);
		}
		break;
	case "BBC":
		scale=gui.newFrame(meter.frame, 5, 552/2-500/2, 286, 500, "img/svg/mtr_scale_surr_bbc.svg");
		createBBClabels(scale, 27);
		for(n=0; n<8; n++)
		{
			m[n]=gui.newMeterEx(scale, 20+(n>1)*33+27*n, 0, 22, 500, "img/svg/mbar_ex_h5.svg");
			m[n].setPoints([-200-180, 0, -120-180, 5, 120-180, 95, 150-180, 100]);
			m[n].setCPoint(83);
		}
		break;
	}
	gui.createMeter(guiId, 4, meter.peak, m, meter.phase);
	gui.linkMeter(guiId, engId);
	host.requestMeter(engId, true);
	meterSetConstants(engId, meter_getTimeConstants(type));

	meter.parent=frm;
	meter.x=x;
	meter.guiId=guiId;
	meter.engId=engId;
	meter.type=type;
	meter.surround=true;
	meter.destroy=function()
	{
	//gui.deleteMeter(this.guiId);
		host.requestMeter(this.engId, false);
		this.frame.destroy();
		this.peak.destroy();
	}
	meter.create=createFusionSurroundMultiMeter;
	return meter;
}

function reCreateMultiMeter(meter, newType)
{
	if(newType==meter.type) return meter;

// remove old meter
	meter.destroy();
	return meter.create(meter.parent, meter.x, meter.guiId, meter.engId, newType);
}

function changeMeterBallistics(newType)
{
	var n;

	if(!(newType in mtrTypes)) newType=0;
	host.cfgSetInteger('meter.ballistics', newType);

	for(n in mtr_meter)
		mtr_meter[n]=reCreateMultiMeter(mtr_meter[n], mtrTypes[newType]);
}

/*
** makeMeters
**
** creates 4 main meters
*/
function makeMeters(lblock, rblock)
{
	var mframe, ballistics;

	if(cfg_fusionUI)
	{
	// Request all the main meters with phase and LU
		host.requestMeter(mtrEng.main1, 0x7C);
		host.requestMeter(mtrEng.main2, 0x7C);
		host.requestMeter(mtrEng.main3, 0x7C);
		host.requestMeter(mtrEng.main4, 0x7C);
		host.requestMeter(mtrEng.main5, 0x7C);
		host.requestMeter(mtrEng.main6, 0x7C);
	}
	else
	{
	// Request all the main meters with LU
		host.requestMeter(mtrEng.main1, 0x3C);
		host.requestMeter(mtrEng.main2, 0x3C);
		host.requestMeter(mtrEng.main3, 0x3C);
		host.requestMeter(mtrEng.main4, 0x3C);
	}

	if(!cfg_fusionUI && cfg_surroundMode)
	{
	// PGM1 5.1+Stereo Meter
		mframe=gui.newFrame(lblock, 12, 25, 233, 451, "img/dk_meter_surr.png");
		createSurroundMeter(mframe, mtrGUI.main1, mtrEng.main1);
		mtr_label[1]=GUI_createMeterLabel(mframe, 40, 425, "PGM 1", false);

	// PGM2/CR/Preview 5.1+Stereo Meter
		mframe=gui.newFrame(rblock, 12, 25, 233, 451, "img/dk_meter_surr.png");
		createSurroundMeter(mframe, mtrGUI.main2, mtrEng.main2);
		mtr_label[2]=GUI_createMeterLabel(mframe, 40, 425, "PGM 2", false);

	// PGM3/PGM4 are not used, assign dummy objects to them
		mtr_label[3]=mtr_label[4]=mtr_label[5]=mtr_label[6]=createFakeMeterLabel();

	// Rightmost label is special
		mtr_label_right=mtr_label[2];
	// Set Meter Sources
		mtrxSelectMeter(mtrEng.main1, mtrEng.pgm1);     // 1st meter - Program 1
		mtrxSelectMeter(mtrEng.main2, mtrEng.pgm2sw);   // 2nd meter - Program 2 follows MET4.SRSW
	}
	else
	{
		ballistics=host.cfgGetInteger('meter.ballistics', 0);
		if(!(ballistics in mtrTypes)) ballistics=0;

		if(cfg_fusionUI)
		{
			const yl=32+12+520+12+32+1;

			if(!cfg_surroundMode)
			{
				mtr_label[1]=GUI_createMeterLabel(lblock, 146+0, yl, "PGM 1", false);
				mtr_meter[1]=createFusionMultiMeter(lblock, 146+0, mtrGUI.main1, mtrEng.main1, mtrTypes[ballistics]);

				mtr_label[2]=GUI_createMeterLabel(lblock, 146+142+16, yl, "PGM 2", false);
				mtr_meter[2]=createFusionMultiMeter(lblock, 146+142+16, mtrGUI.main2, mtrEng.main2, mtrTypes[ballistics]);

				mtr_label[3]=GUI_createMeterLabel(lblock, 146+(142+16)*2, yl, "PGM 3", false);
				mtr_meter[3]=createFusionMultiMeter(lblock, 146+(142+16)*2, mtrGUI.main3, mtrEng.main3, mtrTypes[ballistics]);

				mtr_label[4]=GUI_createMeterLabel(rblock, 0, yl, "PGM 4", false);
				mtr_meter[4]=createFusionMultiMeter(rblock, 0, mtrGUI.main4, mtrEng.main4, mtrTypes[ballistics]);

				mtr_label[5]=GUI_createMeterLabel(rblock, 142+16, yl, "PREVIEW", false);
				mtr_meter[5]=createFusionMultiMeter(rblock, 142+16, mtrGUI.main5, mtrEng.main5, mtrTypes[ballistics]);

				mtr_label[6]=GUI_createMeterLabel(rblock, (142+16)*2, yl, "MONITOR", false);
				mtr_meter[6]=createFusionMultiMeter(rblock, (142+16)*2, mtrGUI.main6, mtrEng.main6, mtrTypes[ballistics]);
			}
			else
			{
				mtr_label[1]=GUI_createMeterLabel(lblock, 0, yl, "PGM 1", true);
				mtr_meter[1]=createFusionSurroundMultiMeter(lblock, 0, mtrGUI.main1, mtrEng.main1, mtrTypes[ballistics]);

				mtr_label[2]=GUI_createMeterLabel(lblock, 296+12, yl, "PGM 2", true);
				mtr_meter[2]=createFusionSurroundMultiMeter(lblock, 296+12, mtrGUI.main2, mtrEng.main2, mtrTypes[ballistics]);

				mtr_label[3]=GUI_createMeterLabel(rblock, (142+12)*0, yl, "PGM 3", false);
				mtr_meter[3]=createFusionMultiMeter(rblock, (142+12)*0, mtrGUI.main3, mtrEng.main3, mtrTypes[ballistics]);

				mtr_label[4]=GUI_createMeterLabel(rblock, (142+12)*1, yl, "PGM 4", false);
				mtr_meter[4]=createFusionMultiMeter(rblock, (142+12)*1, mtrGUI.main4, mtrEng.main4, mtrTypes[ballistics]);

				mtr_label[5]=GUI_createMeterLabel(rblock, (142+12)*2, yl, "PREVIEW", false);
				mtr_meter[5]=createFusionMultiMeter(rblock, (142+12)*2, mtrGUI.main5, mtrEng.main5, mtrTypes[ballistics]);

				mtr_label[6]=GUI_createMeterLabel(rblock, (142+12)*3, yl, "MONITOR", false);
				mtr_meter[6]=createFusionMultiMeter(rblock, (142+12)*3, mtrGUI.main6, mtrEng.main6, mtrTypes[ballistics]);
			}
		// Set Meter Sources
			mtrxSelectMeter(mtrEng.main5, mtrEng.prev_dir); // 5th meter - Preview
			mtrxSelectMeter(mtrEng.main6, mtrEng.crmo_dir); // 6th meter - Monitor
		}
		else
		{
			mframe=gui.newFrame(lblock, 14, 17, 102, 472, "img/dk_meter.png");
			mtr_label[1]=GUI_createMeterLabel(mframe, 20, 443, "PGM 1", false);
			mtr_meter[1]=createMultiMeter(mframe, 0, mtrGUI.main1, mtrEng.main1, mtrTypes[ballistics]);

			mframe=gui.newFrame(lblock, 142, 17, 102, 472, "img/dk_meter.png");
			mtr_label[2]=GUI_createMeterLabel(mframe, 20, 443, "PGM 2", false);
			mtr_meter[2]=createMultiMeter(mframe, 0, mtrGUI.main2, mtrEng.main2, mtrTypes[ballistics]);

			mframe=gui.newFrame(rblock, 14, 17, 102, 472, "img/dk_meter.png");
			mtr_label[3]=GUI_createMeterLabel(mframe, 20, 443, "PGM 3", false);
			mtr_meter[3]=createMultiMeter(mframe, 0, mtrGUI.main3, mtrEng.main3, mtrTypes[ballistics]);

			mframe=gui.newFrame(rblock, 142, 17, 102, 472, "img/dk_meter.png");
			mtr_label[4]=GUI_createMeterLabel(mframe, 20, 443, "PGM 4", false);
			mtr_meter[4]=createMultiMeter(mframe, 0, mtrGUI.main4, mtrEng.main4, mtrTypes[ballistics]);

			mtr_label[5]=mtr_label[6]=createFakeMeterLabel();
		}
	// Rightmost label is special
		mtr_label_right=mtr_label[4];
	// Set Meter Sources
		mtrxSelectMeter(mtrEng.main1, mtrEng.pgm1);     // 1st meter - Program 1
		mtrxSelectMeter(mtrEng.main2, mtrEng.pgm2);     // 2nd meter - Program 2
		mtrxSelectMeter(mtrEng.main3, mtrEng.pgm3);     // 3rd meter - Program 3
		mtrxSelectMeter(mtrEng.main4, mtrEng.pgm4sw);   // 4th meter - Program 4 follows MET4.SRSW
	}
}

/*
** GUI_createSmallMeter
**
** Creates small unlinked confidence meter,
** those meters are usually found on source selection screens
*/
function GUI_createSmallMeter(frame, x, y, id)
{
	var mf, ml, mr;

	if(cfg_fusionUI)
	{
		const mbars=7, mpoints=[-500, 0, 0, 7];
		mf=gui.newFrame(frame, x, y, 18, 28, "img/svg/meter_mon.svg");
		ml=gui.newMeter(mf, 0, 0, 9, 28, "img/svg/mbar_mon.svg"); ml.setBars(mbars); ml.setPoints(mpoints);
		mr=gui.newMeter(mf, 9, 0, 9, 28, "img/svg/mbar_mon.svg"); mr.setBars(mbars); mr.setPoints(mpoints);
	}
	else
	{
		mf=gui.newFrame(frame, x, y, 17, 24, "img/mtr_source_bg.png");
		ml=gui.newMeter(mf, 0, 0, 8, 24, "img/mtr_source.png");
		mr=gui.newMeter(mf, 9, 0, 8, 24, "img/mtr_source.png");
		ml.setBars(8); ml.setPoints([-500, 0, 0, 8]);
		mr.setBars(8); mr.setPoints([-500, 0, 0, 8]);
	}
	gui.createMeter(id, 4, null, [ml, mr]);
}

/*
** GUI_createMediumMeter
**
** Creates medium sized linked meter,
** those meters are usually found on custom external meter screen
*/
function GUI_createMediumMeter(frm, x, y, id, engId)
{
	var mf, ml, mr, p;

	if(cfg_fusionUI)
	{
		p=gui.newPicture(frm,  x, y+3, 96, 14, "img/svg/meter_peak_extra.svg");
		mf=gui.newFrame(frm, x,  y+8+13+3, 28, 460, "img/svg/meter_mtrx.svg");
		ml=gui.newMeter(mf,  0, 0, 28, 460, "img/svg/mbar_ext.svg"); ml.setBars(92); ml.setPoints([-500, 0, 0, 92]);
		mf=gui.newFrame(frm, x+28+40,  y+8+13+3, 28, 460, "img/svg/meter_mtrx.svg");
		mr=gui.newMeter(mf, 0, 0, 28, 460, "img/svg/mbar_ext.svg"); mr.setBars(92); mr.setPoints([-500, 0, 0, 92]);

		const mlbl=["-  0 -",
					"- 10 -",
					"- 20 -",
					"- 30 -",
					"- 40 -",
					"- 50 -"];
		var lbl, i;
		var d=(460-5)/(mlbl.length-1);
		for (i=0 ; i<mlbl.length ;  i++)
		{
			lbl=gui.newLabel(frm, x+28, y+18+i*d, 40, 14, '', {font:fontSemiBold(10), color:color.lgray, align:gui.CENTER, valign:gui.MIDDLE});
			lbl.setText(mlbl[i]);
		}
	}
	else
	{
		mf=gui.newFrame(frm, x,  y, 70, 196, "img/meter_mtrx.png");
		ml=gui.newMeter(mf,  5, 11, 14, 184, "img/mbar_ext.png"); ml.setBars(46); ml.setPoints([-500, 0, 0, 46]);
		mr=gui.newMeter(mf, 51, 11, 14, 184, "img/mbar_ext.png"); mr.setBars(46); mr.setPoints([-500, 0, 0, 46]);
		p=gui.newPicture(mf,  5, 0, 60, 8, "img/meter_ovr.png");
	}

	gui.createMeter(id, 4, p, [ml, mr]);
	gui.linkMeter(id, engId);
}
