// ------------------------- * global variables * -------------------------
var txtChn=[];
// UI timeouts
var confModeTO=null, ipPageTO=null, timerPageTO=null, showRestoreTO=null;

function makeTags()
{
	var n;
	for(n=1; n<=64; n++)
		txtChn[n]=host.sprintf("mCH%02d", n);
}
makeTags();

// ------------------------- * persistent configuration * -------------------------

/*
** readConfiguration
*/
function readConfiguration()
{
/* read configuration values */
	cfg_surroundMode =host.cfgGetString ('scr.surroundMode',  cfg_surroundMode?'yes':'no')=='yes';
	right_mtr_tag    =cfg_surroundMode?'mMET2':'mMET4';
	cfg_clock24hour  =host.cfgGetString ('scr.clock24hour',   cfg_clock24hour ?'yes':'no')=='yes';
	cfg_clocksmooth  =host.cfgGetString ('scr.clocksmooth',   cfg_clocksmooth ?'yes':'no')=='yes';
	cfg_countdownfrom=host.cfgGetInteger('scr.countdownFrom', cfg_countdownfrom);
	cfg_countdownfrom=clamp(cfg_countdownfrom, 0, timerMaxValue);
	chnArmedStyle    =host.cfgGetInteger('scr.armedstyle', chnArmedStyle);
}

// ------------- * create all graphical objects * -------------------

function initGUI()
{
	var i, j;
	var lblock, rblock;

	log.info_f("Version %s (%s) %s", version, version_date, host.getIdentity());
	readConfiguration();

	cur_show_name="-- NO SHOW --";
	cur_show_id=null; // id of current show, initially not set
	cur_show_loading=false; // true if some profile is loading, false if not loading
	pview_interlock =false;  // preview interlock mode
	recmode_enabled =0;      // Record Mode assumed not enabled
	recmode_rcdrlpid=0;      // Recorder's LPID for Record Mode
	recmode_active  =false;  // Record Mode is initially off

	for(i=1; i<=64; i++) rxHandlersCh[i]={};

	mstEnable=
	{
		mask    : 0,
	// Channel Options
		chn_src : true, //  1 Source
		chn_eq  : true, //  2 EQ&Dynamics
		chn_pan : true, //  3 PAN&Mode
		chn_aux : true, //  4 AUX / SENDS
		chn_feed: true, //  5 Feed to Source
		opt_mon : true, //  6 Monitor Options
		opt_mtr : true, //  7 Meter Options
		opt_snd : true, //  8 Sends & Returns
		opt_fdr : true, //  9 Fader Options
		delay   : true, // 10 Delay (all keys 'dump', 'ext', 'pause' and 'engage' together)
		timer   : true, // 11 Timer (all keys 'options', 'reset', 'freeze' and 'start/stop' together)
		ttmon2  : true, // 12 Talk to Monitor 2
		prev_hp : true, // 13 Preview to HP
		link    : true, // 14 Link
		numpad  : true, // 15 Numeric Keypad
		crmo_pgm: true, // 16 Programs  CR Monitor (all keys '1', '2', '3' and '4' together)
		crmo_aux: true, // 17 AUX SENDS CR Monitor (all keys 'A', 'B', 'C' and 'D' together)
		crmo_ext: true, // 18 Externals CR Monitor (both keys '1' and '2' together)
		crhp_pgm: true, // 19 Programs  Headphones (all keys '1', '2', '3' and '4' together)
		crhp_aux: true, // 20 AUX SENDS Headphones (all keys 'A', 'B', 'C' and 'D' together)
		crhp_ext: true, // 21 Externals Headphones (both keys '1' and '2' together)
		src_stmo: true, // 22 ST Monitor source selection
		vol_crmo: true, // 23 Volume Control of CR Monitor (CRMO)
		vol_stmo: true, // 24 Volume Control of ST Monitor (STMO)
		vol_crhp: true, // 25 Volume Control of Headphones (CRHP)
		vol_prev: true, // 26 Volume Control of Preview
		stmo_pgm: true, // 27 Programs  ST Monitor
		stmo_aux: true, // 28 AUX SENDS ST Monitor
		stmo_ext: true, // 29 Externals ST Monitor
		update: function(mask)
		{
			this.mask=mask; // Cache Mask
			this.chn_src =((mask&(1<<0))!=0);
			this.chn_eq  =((mask&(1<<1))!=0);
			this.chn_pan =((mask&(1<<2))!=0);
			this.chn_aux =((mask&(1<<3))!=0);
			this.chn_feed=((mask&(1<<4))!=0);

			this.opt_mon=((mask&(1<<5))!=0);
			this.opt_mtr=((mask&(1<<6))!=0);
			this.opt_snd=((mask&(1<<7))!=0);
			this.opt_fdr=((mask&(1<<8))!=0);

			this.delay  =((mask&(1<<9))!=0);
			this.timer  =((mask&(1<<10))!=0);
			this.ttmon2 =((mask&(1<<11))!=0);
			this.prev_hp=((mask&(1<<12))!=0);
			this.link   =((mask&(1<<13))!=0);
			this.numpad =((mask&(1<<14))!=0);

			this.crmo_pgm=((mask&(1<<15))!=0);
			this.crmo_aux=((mask&(1<<16))!=0);
			this.crmo_ext=((mask&(1<<17))!=0);

			this.crhp_pgm=((mask&(1<<18))!=0);
			this.crhp_aux=((mask&(1<<19))!=0);
			this.crhp_ext=((mask&(1<<20))!=0);

			this.src_stmo=((mask&(1<<21))!=0);
			this.vol_crmo=((mask&(1<<22))!=0);
			this.vol_stmo=((mask&(1<<23))!=0);
			this.vol_crhp=((mask&(1<<24))!=0);
			this.vol_prev=((mask&(1<<25))!=0);

			this.stmo_pgm=((mask&(1<<26))!=0);
			this.stmo_aux=((mask&(1<<27))!=0);
			this.stmo_ext=((mask&(1<<28))!=0);
		}
	};

// init channel table
	chnInitTable();

// External Sources status
	ext1_src_status=128;
	ext2_src_status=128;

	mon_link=false;
	mon_hppvmo=1;
	mon_mon1src=0;
	mon_hpsrc=0;
	upTimerObj=null; // will be created in main page new Timer();
	dnTimerObj=null; // will be created in main page new Timer();
// make jog wheel less sensitive
	jogDelta =0;
	crmo_lpid=0;
	stmo_lpid=0;
	prdl_lpid=0;
	utmr_lpid=0;
	dtmr_lpid=0;
	lumtr_lpid=0;

	mode_txt=cfg_surroundMode?mode_txt_surround:mode_txt_stereo;

	gui_Create();

// Request Confidence Meters
	host.requestMeter(mtrEng.chnConf, true);
}

function onMasterRotaryEvent(index, delta, newValue)
{
	switch(index)
	{
	case knobs.MstJog: // Jog wheel
		jogDelta+=delta;
		if(jogDelta>4 || jogDelta<-4)
		{
			sknobsOnRot('jog', (jogDelta>0)?1:-1);
			jogDelta=0;
		}
		break;
	case knobs.MstMon2: // ST Monitor gain
	case knobs.CmbMon2:
		if(page_active.id=="monsrc" && page_active.channel==chn_mon2)
			sknobsOnRot('jog', delta);
		else if(mstEnable.vol_stmo)
			adjustMonGain("wSTMG", gui_monitors.stmo.vol, delta, 35);
		break;
	case knobs.CmbPview:
		if(page_active.id=="monsrc" && page_active.channel==chn_hp)
		{
			sknobsOnRot('jog', delta);
			break;
		}
		/* fall through to change preview gain */
	case knobs.MstPview: // Preview gain
		if(mstEnable.vol_prev) adjustMonGain("wPVWG", gui_monitors.prev.vol, delta, 35);
		break;
	case knobs.MstMon1: // CR Monitor gain
	case knobs.CmbMon1:
		if(mstEnable.vol_crmo) adjustMonGain("wCRMG", gui_monitors.crmo.vol, delta, 10);
		break;
	case knobs.MstHP: // HP gain
	case knobs.CmbHP:
		if(mstEnable.vol_crhp) adjustMonGain("wCRHG", gui_monitors.crhp.vol, delta, 10);
		break;
	default:
		if(index>=knobs.MstSknob1 && index<=knobs.MstSknob6)
			sknobsOnRot(index-knobs.MstSknob1, delta);
		else if(index>=knobs.CmbSknob1 && index<=knobs.CmbSknob3)
			sknobsOnRot(6+(index-knobs.CmbSknob1), delta);
		break;
	}
}

// capture
function confStart()
{
	confModeTO=null;
	activatePage(pages.help, 1);
}
// ip page
function ipPageStart()
{
	ipPageTO=null;
	activatePage(pages.ip, null);
}
// timer page
function timerPageStart()
{
	timerPageTO=null;
	activatePage(pages.timer, null);
}
// restore current show
function showRestoreStart()
{
	showRestoreTO=null;
// reload current show
	host.sendNestCmsg('mSHOW', {id:"WRIN", dSHWI:cur_show_id});
}
var comboMtrxUsed=false;

function onMasterKeyDown(key)
{
	switch(key)
	{
	// navigation keys
	case keys.MstEnter:
		if(gui_indi.numpadEvent(13, true)) break;
		sknobsPress('enter');
		break;
	case keys.MstUp:
		sknobsOnRot('updn', 1);
		break;
	case keys.MstDown:
		sknobsOnRot('updn', -1);
		break;
	case keys.MstLeft:
		if(gui_indi.numpadEvent(12, true)) break;
		sknobsOnRot('ltrt', -1);
		break;
	case keys.MstRight:
		sknobsOnRot('ltrt', 1);
		break;
	case keys.MstHelp:
	// configuration mode
		confModeTO=host.resetTimeout(confModeTO, 5000, confStart);
		break;

	//global options
	case keys.MstProfile:
	case keys.CmbProfile:
	// show page on short push, restore current show on push and hold
		showRestoreTO=host.resetTimeout(showRestoreTO, 5000, showRestoreStart);
		break;
	case keys.MstMonOpt:
		if(!mstEnable.opt_mon) break;
		activatePage(pages.monopt, null);
		break;
	case keys.MstMetOpt:
		if(!mstEnable.opt_mtr) break;
		activatePage(pages.meters, null);
		break;
	case keys.MstSendRet:
		if(!mstEnable.opt_snd) break;
		if(page_active==pages.sends || page_active==pages.returns)
			activatePage(pages.returns, null); // open returns if sends is open, or close returns if returns is already open
		else
			activatePage(pages.sends, null);
		break;
	case keys.MstFaderOpt:
		ipPageTO=host.clearTimeout(ipPageTO);
		if(page_active==pages.ip) // if already open, then close immediately
			activatePage(pages.ip, null);
		else if(page_active==pages.sound4) // if already open, then close immediately
			activatePage(pages.sound4, null);
		else // ip screen after 5 sec
			ipPageTO=host.setTimeout(5000, ipPageStart);
		break;

	//channel options
	case keys.MstChnSrc:
		chSwitchToPage(pages.chsrc);
		break;
	case keys.MstChnEq:
		if((page_active==pages.cheq || page_active==pages.chmicproc)
		    && ('channel' in page_active)
		    && ch_data[page_active.channel].srct!=srct.line && ch_data[page_active.channel].srct!=srct.computer)
			// open micproc or go back to main
			chSwitchToPage(pages.chmicproc);
		else
			chSwitchToPage(pages.cheq);
		break;
	case keys.MstChnPan:
		chSwitchToPage(pages.chpan);
		break;
	case keys.MstChnAux:
		chSwitchToPage(pages.chaux);
		break;
	case keys.MstChnM1:
		chSwitchToPage(pages.chm1);
		break;

	// delay
	case keys.MstDump:
		if(!prdl_lpid)
			lwcpSendMonButEvent(1, true);
		else if(mstEnable.delay)
			sendGPIOcommand(prdl_lpid, 8, gpio.on);
		break;
	case keys.MstExit:
		if(!prdl_lpid)
			lwcpSendMonButEvent(2, true);
		else if(mstEnable.delay)
			sendGPIOcommand(prdl_lpid, 7, gpio.on);
		break;
	case keys.MstPause:
		if(!prdl_lpid)
			lwcpSendMonButEvent(3, true);
		else if(mstEnable.delay)
			sendGPIOcommand(prdl_lpid, 6, gpio.on);
		break;
	case keys.MstEngage:
		if(!prdl_lpid)
			lwcpSendMonButEvent(4, true);
		else if(mstEnable.delay)
			sendGPIOcommand(prdl_lpid, 5, gpio.on);
		break;

// timer
	case keys.MstTimerOpt:
	case keys.CmbTimerOpt:
		if(!mstEnable.timer) break;
		timerPageTO=host.resetTimeout(timerPageTO, 5000, timerPageStart);
		break;
	case keys.MstTimerReset:
	case keys.CmbTimerReset:
		if(cfg_loudness)
			gui.resetLUmeter(mtrEng.main1);
		else if(mstEnable.timer)
			upTimerObj.reset();
		break;
	case keys.MstTimerPause:
	case keys.CmbTimerPause:
		if(!mstEnable.timer) break;
		upTimerObj.freeze();
		break;
	case keys.MstTimerStart:
	case keys.CmbTimerStart:
		if(cfg_loudness)
			gui.stopLUmeter(mtrEng.main1);
		else if(mstEnable.timer)
			upTimerObj.toggleStart();
		break;

	case keys.MstRecord:
	case keys.CmbRecord:
		if(recmode_active)
			deactivateRecordMode();
		else
			activateRecordMode();
		break;

// Monitor Section
// Monitor2 (STMO)
	case keys.CmbMon2Knob:
		if(mod.getMasterKey(keys.CmbMonOpt))
		{
		// Extra Meters Page activation
			comboMtrxUsed=true;
			activatePage(pages.mtrx, null);
			break;
		}
	/* fall through */
	case keys.MstMon2Knob:
		if(page_active.id=="monsrc" && page_active.channel==chn_mon2)
			sknobsPress('enter');
		if(mstEnable.src_stmo) activatePage(pages.monsrc, chn_mon2);
		break;
	case keys.CmbPviewKnob:
		if(page_active.id=="monsrc" && page_active.channel==chn_hp)
			sknobsPress('enter');
		if(!mon_link) activatePage(pages.monsrc, chn_hp);
		break;
	case keys.MstTalkToMon2:
	case keys.CmbTalkToMon2:
		if(!mstEnable.ttmon2) break;
		host.sendNestCmsg('mTALK', {id:"WRIN", bSTUD:1});
		break;
	case keys.MstPvwToHp:
	case keys.CmbPvwToHp:
		if(!mstEnable.prev_hp) break;
		host.sendNestCmsg('mCRHP', {id:"WRIN", bPVMO:(mon_hppvmo%3+1)});
		break;
	case keys.MstLink:
		if(!mstEnable.link) break;
		host.sendNestCmsg('mCRHP', {id:"WRIN", bINDP:(mon_link?2:1)});
		break;
// Monitor1 (CRMON)
	case keys.MstMon1Pgm1:
	case keys.MstMon1Pgm2:
	case keys.MstMon1Pgm3:
	case keys.MstMon1Pgm4:
	case keys.CmbMonPgm1:
	case keys.CmbMonPgm2:
	case keys.CmbMonPgm3:
	case keys.CmbMonPgm4:
		if(!mstEnable.crmo_pgm) break;
		onMon1KeyDown(key);
		break;
	case keys.MstMon1AuxA:
	case keys.MstMon1AuxB:
	case keys.MstMon1AuxC:
	case keys.MstMon1AuxD:
		if(!mstEnable.crmo_aux) break;
		onMon1KeyDown(key);
		break;
	case keys.MstMon1Ext1:
	case keys.MstMon1Ext2:
	case keys.CmbMonExt1:
	case keys.CmbMonExt2:
		if(!mstEnable.crmo_ext) break;
		onMonExtKeyDown(key);
		break;

// Headphones (CRHP)
	case keys.MstHpPgm1:
	case keys.MstHpPgm2:
	case keys.MstHpPgm3:
	case keys.MstHpPgm4:
		if(!mstEnable.crhp_pgm) break;
		onHpKeyDown(key);
		break;
	case keys.MstHpAuxA:
	case keys.MstHpAuxB:
	case keys.MstHpAuxC:
	case keys.MstHpAuxD:
		if(!mstEnable.crhp_aux) break;
		onHpKeyDown(key);
		break;
	case keys.MstHpExt1:
	case keys.MstHpExt2:
		if(!mstEnable.crhp_ext) break;
		onMonExtKeyDown(key);
		break;

// cases that doesn't map to one single key
	default:
		if(key>=keys.MstSknob1 && key<=keys.MstSknob6)
			sknobsOnDn(key-keys.MstSknob1);
		else if(key>=keys.CmbSknob1 && key<=keys.CmbSknob3)
			sknobsOnDn(6+(key-keys.CmbSknob1));
		else if(key>=keys.MstNum0 && key<=keys.MstNumNum)
			onDTMFkeyDown(key-keys.MstNum0);
		else if(key>=keys.CmbNum0 && key<=keys.CmbNumNum)
			onDTMFkeyDown(key-keys.CmbNum0);
		break;
	}
}

function onMasterKeyUp(key)
{
	switch(key)
	{
	case keys.MstProfile:
	case keys.CmbProfile:
	// show page on short push, restore current show on push and hold
		if(showRestoreTO!=null)
		{
			showRestoreTO=host.clearTimeout(showRestoreTO);
			activatePage(pages.show, null);
		}
		break;
	case keys.MstHelp:
		// configuration mode
		if(confModeTO!=null)
		{
			confModeTO=host.clearTimeout(confModeTO);
			activatePage(pages.help, null);
		}
		break;
	case keys.MstFaderOpt:
	// ip screen on push and hold, faders screen on short push
		if(ipPageTO!=null)
		{
		// short push
			ipPageTO=host.clearTimeout(ipPageTO);
			activatePage(pages.sound4, null);
		}
		break;
	case keys.CmbMonOpt:
		if(!mstEnable.opt_mon) break;
		if(comboMtrxUsed)
		{
			comboMtrxUsed=false;
			break;
		}
		if(page_active==pages.monopt || page_active==pages.monopt2)
			activatePage(pages.monopt2, null);
		else
			activatePage(pages.monopt, null);
		break;

	// delay
	case keys.MstDump:
		if(!prdl_lpid)
			lwcpSendMonButEvent(1, false);
		else if(mstEnable.delay)
			sendGPIOcommand(prdl_lpid, 8, gpio.off);
		break;
	case keys.MstExit:
		if(!prdl_lpid)
			lwcpSendMonButEvent(2, false);
		else if(mstEnable.delay)
			sendGPIOcommand(prdl_lpid, 7, gpio.off);
		break;
	case keys.MstPause:
		if(!prdl_lpid)
			lwcpSendMonButEvent(3, false);
		else if(mstEnable.delay)
			sendGPIOcommand(prdl_lpid, 6, gpio.off);
		break;
	case keys.MstEngage:
		if(!prdl_lpid)
			lwcpSendMonButEvent(4, false);
		else if(mstEnable.delay)
			sendGPIOcommand(prdl_lpid, 5, gpio.off);
		break;

	// clock timer screen
	case keys.MstTimerOpt:
	case keys.CmbTimerOpt:
		if(!mstEnable.timer) break;
		if(timerPageTO==null) return; // timer fired, skip this event

		timerPageTO=host.clearTimeout(timerPageTO);

		if(page_active==pages.timer)
			activatePage(pages.timer, null); // close timer options screen
		else
			mainShowTimerCtrl(key==keys.CmbTimerOpt);
		break;
	case keys.MstTimerPause:
	case keys.CmbTimerPause:
		if(!mstEnable.timer) break;
		upTimerObj.unfreeze(); // TODO: need to check if other key is pressed
		break;

	// Monitor section
	// Studio Monitor
	case keys.MstTalkToMon2:
	case keys.CmbTalkToMon2:
		if(!mstEnable.ttmon2) break;
		host.sendNestCmsg('mTALK', {id:"WRIN", bSTUD:0});
		break;
	// CR Monitor
	case keys.MstMon1Ext1:
	case keys.MstMon1Ext2:
	case keys.CmbMonExt1:
	case keys.CmbMonExt2:
		if(!mstEnable.crmo_ext) break;
		onMonExtKeyUp(key);
		break;
	// Headphones
	case keys.MstHpExt1:
	case keys.MstHpExt2:
		if(!mstEnable.crhp_ext) break;
		onMonExtKeyUp(key);
		break;

// cases that doesn't map to one single key
	default:
		if(key>=keys.MstSknob1 && key<=keys.MstSknob6)
			sknobsOnUp(key-keys.MstSknob1);
		else if(key>=keys.CmbSknob1 && key<=keys.CmbSknob3)
			sknobsOnUp(6+(key-keys.CmbSknob1));
		else if(key>=keys.MstNum0 && key<=keys.MstNumNum)
			onDTMFkeyUp(key-keys.MstNum0);
		else if(key>=keys.CmbNum0 && key<=keys.CmbNumNum)
			onDTMFkeyUp(key-keys.CmbNum0);
		break;
	}
}

// ------------------------- * Keypad Functions * -------------------------
var dtmfAsteriskTimer=null;
function dtmfAsteriskAction()
{
	var n, v;

	dtmfAsteriskTimer=null;
	for(n=0, v=0; n<12; n++)
		if(mod.getMasterKey(keys.MstNum0+n) || mod.getMasterKey(keys.CmbNum0+n))
			v|=(1<<n);

	switch(v)
	{
	case (1<<10)|(1<< 2): // "*" & "2" - capture mode
		mod.enterCapture();
		break;
	case (1<<10)|(1<<11): // "*" & "#" - help screen
		activatePage(pages.help, null);
		break;
	case (1<<10)|(1<<2)|(1<<11): // "*" & "2" & "#" - test mode
		if(testAttached) mod.testBegin();
		break;
	case (1<<10)|(1<<4)|(1<<7): // "*" & "4" & "7" - IP screen
		activatePage(pages.ip, null);
		break;
	case (1<<10)|(1<<4)|(1<<8): // "*" & "4" & "8" - Sound4/Voice8 screen
		activatePage(pages.sound4, null);
		break;
	}
}

function onDTMFkeyDownEx(key)
{
	if(!mstEnable.numpad) return;

/* first send numpad event to screens */
	if(onNumpadDown(key)) return;
/* if not utilized yet - send to dialpad */
	if(gui_indi.numpadEvent(key, true)) return;
/* finally send to phone system as DTMF */
	phoneDTMF(key);
}

function onDTMFkeyDown(key)
{
	if(key==10) // "*"
	{
		dtmfAsteriskTimer=host.resetTimeout(dtmfAsteriskTimer, 5000, dtmfAsteriskAction);
		return;
	}
	if(dtmfAsteriskTimer) return;
	onDTMFkeyDownEx(key);
}

function onDTMFkeyUp(key)
{
	if(dtmfAsteriskTimer)
	{
	// timer in progress
		if(key==10) // "*"
		{
			dtmfAsteriskTimer=host.clearTimeout(dtmfAsteriskTimer);
			onDTMFkeyDownEx(key);
		}
		else
			return;
	}

	if(!mstEnable.numpad) return;
	if(gui_indi.numpadEvent(key, false)) return;
}

/*
** onConfigChange
**
** called when host configuration changes. Includes:
**  * fader channel configuration
**  * phone channel configuration
**
** updates internal script config and sends message to acl
** CONF
**   CMSG - string - current channel mask
**   PHON - message - phone channel data
**   SURR - byte   - signal mode - surround or stereo
*/
function onConfigChange()
{
	var ch_config, ph_config;
	var conf_msg={id:'WRNI'};

// get configuration
	ch_config=mod.getChnConfig();
	ph_config=mod.getPhoneConfig();

// fader channels
	conf_msg.sCMSK=chnInitMask(ch_config);
// phone channels
	conf_msg.sPHON=phUS_UpdateChnInfo(ph_config);
// signal mode
	conf_msg.bSURR=cfg_surroundMode?1:0;

// send config message
	host.sendInitCmsg({id:'NEST', mCONF:conf_msg});

// send fader levels
	chnUpdateFaderLevels();

	log.info("Scripts: channel config changed & sent to ACL");
}

function onHostCfgChange()
{
// this function is called when host configuration is changed
	log.info("Scripts: host configuration is changed");
	readConfiguration();
/* TODO: make use of a new configuration */
	applyLUmeterOptions();
}

// ------------------------- * SSC source list update handling * -------------------------
var list_update=false;
var new_update=null;

/*
** onSrcListUpdate
*/
function onSrcListUpdate(mask)
{
	var n, tMsk;

	if(!list_update)
	{
		tMsk=mask;
		while(1)
		{
			list_update=true;
		// notify anybody who cares
			if('onSrcLstUpdate' in page_active) page_active.onSrcLstUpdate(tMsk);
			if(prod_channel!=null) prodSrcReload(tMsk);
			host.sleep(500); // don't allow to reload list too frequently
			list_update=false;
		// check if there've been other updates during processing
			if(new_update==null) break;
			tMsk=new_update; new_update=null;
		}
	}
	else if(new_update==null)
		new_update=mask; // copy mask
	else
	{
	// merge update masks
		for(n in mask)
			new_update[n]+=mask[n];
	}
}

/*
** onRecvMsg
**
** event on incoming Cmsg
*/
function onRecvMsg(msg)
{
	var subm, n, ind, txt;

	if(msg.id=='HSTR')
	{
		var resp;

	// channel messages
		for(ind in msg)
		{
			if(ind.substr(0,3)=='mCH')
			{
				n=parseInt(ind.substr(3,2), 10);
				if(!(n in ch_data) || !ch_data[n].exists) continue;
				subm=msg[ind];

				if(subm.id=='WRNI')
				{
					if('wFAGN' in subm)
					{
						chnSetFaderGain(n, subm.wFAGN/10);
					}
				}
				if(subm.id=='READ')
				{
					if('bFAGN' in subm)
					{
						resp={id:'HSTO'};
						resp[ind]={id:'INDI','wFAGN':clamp(chnGetFaderGain(n)*10, -32768, 32767)};
						host.sendRemoteHostCmsg(resp);
					}
					if('bFAMO' in subm)
					{
						resp={id:'NEST'};
						resp[ind]={id:'INDI','bFAMO':ch_data[n].faderStart};
						host.sendRemoteHostCmsg(resp);
					}
					if('bTBCK' in subm)
					{
						resp={id:'NEST'};
						resp[ind]={id:'INDI','bTBCK':ch_data[n].talkback?1:0};
						host.sendRemoteHostCmsg(resp);
					}
				}
			}
			else if(ind=='mSHOW')
			{
				subm=msg[ind];
				if(subm.id=='READ')
				{
					resp={id:'INDI'};
					if('bSHWI' in subm) resp.dSHWI =cur_show_id;
					if('bSHWN' in subm) resp.bvSHWN=strToArr(cur_show_name);
					host.sendRemoteHostCmsg({id:'NEST', mSHOW:resp});
				}
			}
			else if(ind=='mSUPV')
			{
				subm=msg[ind];
				if(subm.id=='READ')
				{
					resp={id:'INDI'};
					if('bSTAT' in subm) resp.bSTAT=eng_status?9:0;
					host.sendRemoteHostCmsg({id:'NEST', mSUPV:resp});
				}
			}
			else if(ind=='mUSIF')
			{
				subm=msg[ind];
				if(subm.id=='READ')
				{
					resp={id:'INDI'};
					if('bPVIN' in subm) resp.bPVIN=pview_interlock?1:0;
					if('bENBL' in subm) resp.dENBL=mstEnable.mask;
					host.sendRemoteHostCmsg({id:'NEST', mUSIF:resp});
				}
			}
		}
		return;
	}
	if(msg.id=="INDI")
	{
		if('wCRMG' in msg) indiMonGain(msg.wCRMG, gui_monitors.crmo.vol);
		if('wCRHG' in msg) indiMonGain(msg.wCRHG, gui_monitors.crhp.vol);
		if('wPVWG' in msg) indiMonGain(msg.wPVWG, gui_monitors.prev.vol);
		if('wSTMG' in msg) indiMonGain(msg.wSTMG, gui_monitors.stmo.vol);

		if('bSCHG' in msg) gui_indi.setShowChanged(msg.bSCHG);
		if('bvSRLU' in msg) onSrcListUpdate(msg.bvSRLU); // source table updated
		if('bTMRT' in msg)
		{
			timer_tenth_mode=msg.bTMRT;
			upTimerObj.updateTMRT();
			dnTimerObj.updateTMRT();
		}
		if('bTMRM' in msg)
		{
			timer_mode=msg.bTMRM;
			lwSendTimerEvent(true, {Mode:timer_mode}); // FIXME: move to timer code
			timer_mode_ind.setMode(timer_mode);
			if('main' in pages) pages.main.updateTimerMode();
		}
	}
	else if(msg.id=="NEST")
	{
	// user interface
		if('mUSIF' in msg)
		{
			if('bPVIN' in msg.mUSIF) pview_interlock=(msg.mUSIF.bPVIN==1);
			if('dENBL' in msg.mUSIF) mstEnable.update(msg.mUSIF.dENBL);
		}
	// switchable meters
		if('mMTRX' in msg)
		{
			if(('mPGM3' in msg.mMTRX) && ('wNSEL' in msg.mMTRX.mPGM3))
			{
				var nsel=msg.mMTRX.mPGM3.wNSEL;
				mtrxSelectMeter(mtrEng.main3, nsel);
			// Update Label
				if(nsel==mtrEng.pgm3)
					mtr_label[3].setText(null);
				else
					mtr_label[3].setText(mtrxGetDesc(nsel));
			}
		}
	// show
		if(('mSHOW' in msg) && msg.mSHOW.id=="INDI")
		{
		// cur show name
			if('bvSHWN' in msg.mSHOW)
			{
				cur_show_name=host.arrtostr(msg.mSHOW.bvSHWN);
				cur_show_loading=false;
			// update indication on screen
				gui_indi.setShowName(cur_show_name, false);
			// report profile change to LWCP clients
				lwEventProfChange();
			}
		// next show name
			if('bvNXTN' in msg.mSHOW)
			{
				cur_show_name=host.arrtostr(msg.mSHOW.bvNXTN);
				cur_show_loading=true;
				prev_show_id=cur_show_id;
				cur_show_id =msg.mSHOW.dSHWI;
			// update indication on screen
				gui_indi.setShowName(cur_show_name, true);
			// report profile change to LWCP clients
				lwEventProfChange();
			}
		}
		else
		{
			if(('mPREV' in msg) && msg.mPREV.id=='INDI') onPrevIndi(msg.mPREV); // preview
			if(('mSTMO' in msg) && msg.mSTMO.id=='INDI') onMon2Indi(msg.mSTMO); // st monitor (monitor 2)
			if(('mCRMO' in msg) && msg.mCRMO.id=='INDI') onMon1Indi(msg.mCRMO); // cr monitor (monitor 1)
			if(('mCRHP' in msg) && msg.mCRHP.id=='INDI') onHpIndi(msg.mCRHP);   // cr hp monitor (headphones)
		}
		// talk
		if(('mTALK' in msg) && msg.mTALK.id=="INDI")
		{
			if('bTALK' in msg.mTALK) gui_indi.setTalk(msg.mTALK.bTALK);
			if('bSTUD' in msg.mTALK)
			{
			// TODO: remember
				mod.setMasterKeyLed(keys.MstTalkToMon2, msg.mTALK.bSTUD?255:0);
				mod.setMasterKeyLed(keys.CmbTalkToMon2, msg.mTALK.bSTUD?255:0);
			}
			if('bEXTR' in msg.mTALK)
			{
			// TODO: remember
				lwcpSendMonEvent({'tt_ext': (msg.mTALK.bEXTR?"ON":"OFF")});
			}
		}
		else if(('mCONF' in msg) && msg.mCONF.id=='INDI')
		{
		// config messages
			subm=msg.mCONF;
			//if('bNTPS' in subm) (subm.bNTPS==1)?ntp_status.show():ntp_status.hide();
			if(('bNTPO' in subm) && ('dNTPA' in subm) && ('wNTPT' in subm))
			{
			// try to upgrade NTP config here
			// CONF.NTPO: 0=Off,1=On, CONF.NTPA: ip of NTP, CONF.NTPB: ip of back-up NTP, CONF.NTPN - active? 1 or 2, CONF.NTPT: offset in minutes
				if(subm.bNTPO==1 && !host.cfgGetInteger("ntp.enabled", 0))
				{
					host.cfgSetInteger("ntp.enabled", 1);
					host.cfgSetInteger("tz.offset", subm.wNTPT);
					host.cfgSetString("ntp.address", daIP2str(dasmIP(subm.dNTPA)));
					host.sendNestCmsg('mCONF', {id:"WRIN", bNTPO:0, dNTPA:0, wNTPT:0});
				}
			}
		}
		else if(('mMET2' in msg) && ('bvDISP' in msg.mMET2))
		{
		// meter 2 content label
			txt=host.arrtostr(msg.mMET2.bvDISP);
			mtr_label[2].setText((txt=="PGM2")?null:txt);
		}
		else if(('mMET4' in msg) && ('bvDISP' in msg.mMET4))
		{
		// meter 4 content label
			txt=host.arrtostr(msg.mMET4.bvDISP);
			mtr_label[4].setText((txt=="PGM4")?null:txt);
		}
		else if(('mSUPV' in msg) && msg.mSUPV.id=="INDI")
		{
			if('bSTAT' in msg.mSUPV)
			{
				if(msg.mSUPV.bSTAT==9)
				{
				/* Engine Good */
					if(!eng_status)
					{
						eng_status=true;
						updateWarning();
					}
				}
				else
				{
				/* Engine Offline */
					if(eng_status)
					{
						eng_status=false;
						updateWarning();
					}
				}
			}
		}
		else if('mPRDL' in msg)
		{
		// profanity delay
			if(msg.mPRDL.id=='INDI' && ('dLPID' in msg.mPRDL) && prdl_lpid!=msg.mPRDL.dLPID)
			{
				prdl_lpid=msg.mPRDL.dLPID;
				if(prdl_lpid==0)
				{
				// No profanity delay
					mod.setMasterKeyLed(keys.MstDump, 0);
					mod.setMasterKeyLed(keys.MstExit, 0);
					mod.setMasterKeyLed(keys.MstPause, 0);
					mod.setMasterKeyLed(keys.MstEngage, 0);
					gui_indi.setDelay(false);
				}
				else
				{
				// TODO: update GPIO status
				}
			}
		}
		else if(('mATMR' in msg) && ('bCMND' in msg.mATMR))
		{
		// commands for up timer
			switch(msg.mATMR.bCMND)
			{
			case timer_cmd.start:
				upTimerObj.start();
				break;
			case timer_cmd.stop:
				upTimerObj.stop();
				break;
			case timer_cmd.reset:
				upTimerObj.reset();
				break;
			case timer_cmd.reset_start:
				upTimerObj.reset();
				upTimerObj.start();
				break;
			}
		}
		else if('mUTMR' in msg)
		{
		// Up timer
			if(msg.mUTMR.id=='INDI' && ('dLPID' in msg.mUTMR) && utmr_lpid!=msg.mUTMR.dLPID)
			{
				utmr_lpid=msg.mUTMR.dLPID;
			// TODO: update
			}
		}
		else if('mDTMR' in msg)
		{
		// Down timer
			if(msg.mDTMR.id=='INDI' && ('dLPID' in msg.mDTMR) && utmr_lpid!=msg.mDTMR.dLPID)
			{
				dtmr_lpid=msg.mDTMR.dLPID;
			// TODO: update
			}
			if('bCMND' in msg.mDTMR)
			{
			// commands for down timer
				switch(msg.mDTMR.bCMND)
				{
				case timer_cmd.reset_start:
					dnTimerObj.reset();
					dnTimerObj.start();
					break;
				}
			}
		}
		else if('mPHON' in msg)
		{
		// phone stuff
			phUS_UpdateShowInfo(msg.mPHON);
		}
		else if('mRCMO' in msg)
		{
		// Record Mode stuff
			subm=msg.mRCMO;
			if(subm.id=='WRIN')
			{
				if('bENBL' in subm) recmode_enabled=subm.bENBL;
				if(('mRCDR' in subm) && ('dLPID' in subm.mRCDR)) recmode_rcdrlpid=subm.mRCDR.dLPID;
			}
			else if(subm.id=='INDI')
			{
				if('bSTAT' in subm)
				{
					if(subm.bSTAT==0)
						finishDeactivatingRecordMode();
					else
						finishActivatingRecordMode();
				}
			}
		}
		else
		{
		// channel messages
			for(ind in msg)
			{
				if(ind.substr(0,3)=='mCH' ) onChnRecvMsg(parseInt(ind.substr(3,2), 10), msg[ind]);
				if(ind.substr(0,4)=='mRET') onRetRecvMsg(parseInt(ind.substr(4,1), 10), msg[ind]);
			}
		}
	}

// call external handlers
	for(ind in rxHandlersGlobal) rxHandlersGlobal[ind](msg);
}

/*
** sendGPIOcommand
**
** sends GPIO command (uses ACL for now)
*/
function sendGPIOcommand(lpid, circuit, value)
{
	if(lpid==0) return; // lpid of 0 means logic disabled
	host.sendNestCmsg('mGPIO', {id:'WRNI', dLPID:lpid, bvPINN:[circuit], bvVALL:[value]});
}

/*
** onGPIOevent
**
** process incoming GPIO event
*/
function onGPIOevent(lpid, circuit, value)
{
	var n;

// Channel GPIO
	for(n=1; n<=64; n++)
	{
		if(ch_data[n].exists && ch_data[n].lpid==lpid)
			onChnGPIOevent(n, circuit, value);
	}
// CR Monitor
	if(lpid==crmo_lpid)
	{
		switch(circuit)
		{
		case gpioCirc.muteCR:
			host.sendNestCmsg('mCRMO', {id:'WRIN', bMUCM:(value?1:0)});
			break;
		case gpioCirc.dimCR:
			host.sendNestCmsg('mCRMO', {id:'WRIN', bDIMC:(value?1:0)});
			break;
		case gpioCirc.extPreview:
			host.sendNestCmsg('mPREV', {id:'WRIN', bEXON:(value?1:0)});
			break;
		case gpioCirc.talkToExt:
			host.sendNestCmsg('mTALK', {id:'WRIN', bEXTR:(value?1:0)});
			break;
		}
	}
// ST Monitor
	if(lpid==stmo_lpid)
	{
		switch(circuit)
		{
		case gpioCirc.muteST:
			host.sendNestCmsg('mSTMO', {id:'WRIN', bMUCM:(value?1:0)});
			break;
		case gpioCirc.dimST:
			host.sendNestCmsg('mSTMO', {id:'WRIN', bDIMC:(value?1:0)});
			break;
		case gpioCirc.timer:
			if(value)
			{
				upTimerObj.reset();
				upTimerObj.start();
			}
			break;
		case gpioCirc.countdown:
			if(value)
			{
				dnTimerObj.reset();
				dnTimerObj.start();
			}
			break;
		}
	}
// Profanity Delay
	if(lpid==prdl_lpid)
	{
		switch(circuit)
		{
		case gpioCirc.delayDump:
			mod.setMasterKeyLed(keys.MstDump, value?255:0);
			break;
		case gpioCirc.delayExit:
			mod.setMasterKeyLed(keys.MstExit, value?255:0);
			break;
		case gpioCirc.delayPause:
			mod.setMasterKeyLed(keys.MstPause, value?255:0);
			break;
		case gpioCirc.delayEngage:
			mod.setMasterKeyLed(keys.MstEngage, value?255:0);
			break;
		case gpioCirc.delayAnnounce:
			gui_indi.setDelay(value);
			break;
		}
	}
// Up Timer
	if(lpid==utmr_lpid)
	{
		switch(circuit)
		{
		case gpioCirc.timerStart:
			if(value) upTimerObj.start();
			break;
		case gpioCirc.timerStop:
			if(value) upTimerObj.stop();
			break;
		case gpioCirc.timerReset:
			if(value) upTimerObj.reset();
			break;
		case gpioCirc.timerFreeze:
			if(value)
				upTimerObj.freeze();
			else
				upTimerObj.unfreeze();
			break;
		}
	}
// Down Timer
	if(lpid==dtmr_lpid)
	{
		switch(circuit)
		{
		case gpioCirc.timerStart:
			if(value) dnTimerObj.start();
			break;
		case gpioCirc.timerStop:
			if(value) dnTimerObj.stop();
			break;
		case gpioCirc.timerReset:
			if(value) dnTimerObj.reset();
			break;
		case gpioCirc.timerFreeze:
			if(value)
				dnTimerObj.freeze();
			else
				dnTimerObj.unfreeze();
			break;
		}
	}
// Loudness Meter
	if(lpid==lumtr_lpid)
	{
		switch(circuit)
		{
		case gpioCirc.timerStart:
			if(value) gui.stopLUmeter(mtrEng.main1, false);
			break;
		case gpioCirc.timerStop:
			if(value) gui.stopLUmeter(mtrEng.main1, true);
			break;
		case gpioCirc.timerReset:
			if(value) gui.resetLUmeter(mtrEng.main1);
			break;
		}
	}
}

function updateWarning()
{
	switch(net_status)
	{
	case 0:
	default:
		net_status=0;
		gui_indi.showWarning("ERROR: NO NETWORK CONNECTION");
		break;
	case 1:
		if(eng_status)
			gui_indi.showWarning("");
		else
			gui_indi.showWarning("ERROR: NO CONNECTION TO ENGINE");
		break;
	case 2:
		if(eng_status)
			gui_indi.showWarning("WARNING: DUPLEX MISMATCH (CHECK NETWORK SETUP)");
		else
			gui_indi.showWarning("ERROR: NO CONNECTION TO ENGINE");
		break;
	}
}

function onHostNetChange(status)
{
	if(net_status==status) return;

	net_status=status;
	updateWarning();
}
function onHostComChange(status)
{
}
function onClockStateChange(ntp, visual)
{
	if(cfg_clockVisual!=visual)
	{
	// Visual - 0x01 - 24, 0x02 - smooth, 0x100 - digital
		cfg_clock24hour=(visual&1);
		cfg_clocksmooth=(visual&2);
		cfg_clockVisual=visual;
		gui_time.destroy();
		gui_time=create_time_ctrl(pages.main);
	}
// NTP status TODO: make other states: 0 - disabled, 1 - enabled, 2 - synced ok, 3 - sync error
	if('time' in gui_time) gui_time.time.ntp.show(ntp==2);
}
