function chamixPageCreate()
{
	var p, n;
	var f, fr;

	if(!cfg_fusionUI) return;

	p=Page_Create('chamix', 'chn', "");
	f=p.frame;

	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 0, 43, 640, 504, "img/svg/ch_edit_src_bg.svg");
		gui.newFrame(fr, 600, 12, 20, 12, "img/svg/icon_source_list.svg");

	// Enable Disable
		p.chamen=
		{
			title: gui.newLabel(fr, 10, 10, 220, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 10, 28, 220, 40, '', prop.list)
		};
		p.chamen.list.setProps({border:1, font:fontSemiBold(9)});
		p.chamen.title.setText("ENABLE SOURCE INTO AUTOMIX");
	// Weight
		p.chamwg=
		{
			title: gui.newLabel(fr, 330, 10, 220, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 330, 28, 220, 184, '', prop.list)
		};
		p.chamwg.list.setProps({border:1, font:fontSemiBold(9)});
		p.chamwg.title.setText("WEIGHT VALUE");
	// Global Settings
		p.amix=
		{
			title: gui.newLabel(fr, 10, 240, 220, 16, '', prop.value_left_medium),
			atkt:  knobCreate(fr,  50, 260, 80, "ATTACK TIME"),
			relt:  knobCreate(fr, 150, 260, 80, "RELEASE TIME")
		};
		p.amix.title.setText("GLOBAL SETTINGS");
	}

	p.chamen.list.insert("ENABLE", 1);
	p.chamen.list.insert("DISABLE", 0);
	p.chamen.list.select(0);
	for(n=10; n>=1; n--)
		p.chamwg.list.insert(n, n);
	p.chamwg.list.select(0);
	p.amix.atkt.value=0; // XXX
	p.amix.atkt.angle=0;
	p.amix.relt.value=0; // XXX
	p.amix.relt.angle=0;

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "ENABLE", push: "TAKE", list: p.chamen.list},
		{enabled: true, rot: "WEIGHT", push: "TAKE", list: p.chamwg.list},
		{enabled: true, rot: "ATTACK"},
		{enabled: true, rot: "RELEASE"},
		{enabled: false},
		{enabled: true, push: "EXIT"}
	];
	p.sknobs3=
	[
		{enabled: true, rot: "FUNCTION", updn: true, jog: true, enter: true, knob: true, chopt: true},
		{enabled: true, rot: "ATTACK", push: "FUNCTION"},
		{enabled: true, push: "EXIT"}
	];

// locals
	p.knobUsed=false;
	p.kn7fn=-1;
	p.kn7st=0;
	p.kn8fn=3;
// event functions
	p.onOpen =chamixOnOpen;
	p.onClose=chamixOnClose;
	p.onIndi =chamixOnIndi;
	p.onSoftKnobRot =chamixOnSoftKnobRot;
	p.onSoftKnobDown=chamixOnSoftKnobDown;
	p.onSoftKnobUp  =chamixOnSoftKnobUp;

	p.onKnobRot     =function(){this.knobUsed=true;};
	p.onChoptUp     =function(){this.onSoftKnobUp(this.knobUsed?7:9);};
}
function chamixOnOpen(channel_nr)
{
	if(channel_nr==null) return;
	this.channel=channel_nr;
// Indications
	this.title.setChannel(this.channel);
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 255);
	mod.setChnFusionInvert(this.channel, 1);
// Register receive msg handlers
	rxHandlersCh[this.channel].chamix=this;
	rxHandlersGlobal.chamixIndi=chamixOnGlobalIndi;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.knobUsed=false;
	this.kn7fn=-1;
	this.kn7st=0;
	this.kn8fn=3;

	if(mod.comboPresent())
	{
		this.amix.atkt.focus(true);
		this.amix.relt.focus(false);
		sknobsShow(this.sknobs3);
	}
	else
	{
		this.amix.atkt.focus(true);
		this.amix.relt.focus(true);
		sknobsShow(this.sknobs6);
	}

// request current settings for this channel
	var rmsg=host.sendChnCmsgRq(this.channel, {id:"READ", bAMEN:0, bAMWG:0});
	if(rmsg!=null) this.onIndi(rmsg);
// request global options
	rmsg=host.sendCmsgRq({id:"NEST", mAMIX:{id:"READ", bATKT:0, bRELT:0}});
	if(rmsg!=null) chamixOnGlobalIndi(rmsg);
}
function chamixOnClose()
{
	sknobsHide();
// delete receive msg handlers
	delete rxHandlersCh[this.channel].chsrc;
	delete rxHandlersGlobal.chamixIndi;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setChnFusionInvert(this.channel, 0);
}
function chamixOnGlobalIndi(msg)
{
	if('mAMIX' in msg)
	{
		var p=pages.chamix;
	// TODO: process message
		if('wATKT' in msg.mAMIX)
		{
			p.amix.atkt.value=msg.mAMIX.wATKT;
			p.amix.atkt.angle=knobSetValueEx(p.amix.atkt, p.amix.atkt.value, atkt_const);
			sknobsSetOne(2, {angleNrm:p.amix.atkt.angle});
			if(p.kn8fn==3) sknobsSetOne(7, {angleNrm:p.amix.atkt.angle});
		}
		if('wRELT' in msg.mAMIX)
		{
			p.amix.relt.value=msg.mAMIX.wRELT;
			p.amix.relt.angle=knobSetValueEx(p.amix.relt, p.amix.relt.value, relt_const);
			sknobsSetOne(3, {angleNrm:p.amix.relt.angle});
			if(p.kn8fn==4) sknobsSetOne(7, {angleNrm:p.amix.relt.angle});
		}
	}
}
function chamixOnIndi(msg)
{
	if('bAMEN' in msg) setListActive(this.chamen.list, msg.bAMEN);
	if('bAMWG' in msg) setListActive(this.chamwg.list, msg.bAMWG);
}
function chamixOnSoftKnobRot(idx, delta)
{
	if(idx==7)
	{
		if(this.kn7st==0)
		{
			this.kn7fn=clamp(this.kn7fn+delta, 0, 1);
			sknobsSetOne(6, {rot: "FUNCTION", angleNrm:this.kn7fn, push: (["ENABLE","WEIGHT"])[this.kn7fn], list: null});
		}
		return;
	}
	if(idx==8) idx=this.kn8fn;

	switch(idx)
	{
	case 3:
		host.sendNestCmsg('mAMIX', {id:"WRIN", wATKT: valAdjust(this.amix.atkt.value, delta, atkt_const)});
		break;
	case 4:
		host.sendNestCmsg('mAMIX', {id:"WRIN", wRELT: valAdjust(this.amix.relt.value, delta, relt_const)});
		break;
	}
}
function chamixOnSoftKnobDown(idx)
{
	switch(idx)
	{
	case 1: host.sendChnCmsg(this.channel, {id:"WRIN", bAMEN:this.chamen.list.selId}); break;
	case 2: host.sendChnCmsg(this.channel, {id:"WRIN", bAMWG:this.chamwg.list.selId}); break;
	case 7:
		if(this.kn7fn>=0 && this.kn7fn<=1)
		{
			if(this.kn7st==0)
			{
				this.kn7st=1;
				sknobsSetOne(6, {rot: (["ENABLE","WEIGHT"])[this.kn7fn], push: "TAKE", list:([this.chamen.list,this.chamwg.list])[this.kn7fn]});
			}
			else
			{
				this.kn7st=0;
				switch(this.kn7fn)
				{
				case 0: host.sendChnCmsg(this.channel, {id:"WRIN", bAMEN:this.chamen.list.selId}); break;
				case 1: host.sendChnCmsg(this.channel, {id:"WRIN", bAMWG:this.chamwg.list.selId}); break;
				}
				sknobsSetOne(6, {rot: "FUNCTION", angleNrm:this.kn7fn, push: (["ENABLE","WEIGHT"])[this.kn7fn], list: null});
			}
		}
		break;
	case 8:
		if(this.kn8fn==3)
		{
			this.kn8fn=4;
			sknobsSetOne(7, {rot: "RELEASE", angleNrm:this.amix.relt.angle});
			this.amix.atkt.focus(false);
			this.amix.relt.focus(true);
		}
		else
		{
			this.kn8fn=3;
			sknobsSetOne(7, {rot: "ATTACK", angleNrm:this.amix.atkt.angle});
			this.amix.atkt.focus(true);
			this.amix.relt.focus(false);
		}
		break;
	}
}
function chamixOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 6:
	case 9: // Combo3
		chSwitchToPage(this); // will effectively go back to chopt page
		break;
	}
}
