// ------------------------- * common EQ page code * -------------------------

function eqPageBandCreate(f, x, y, props)
{
	var obj={};

	if(cfg_fusionUI)
	{
		obj.title=gui.newLabel(f, x+28, y, 50, 14, '', {font:fontSemiBold(9), color:color.white, align:gui.CENTER, valign:gui.MIDDLE});
		obj.title.setText(props.title);
	// 2 knobs with labels and values
		obj.gain=knobCreate(f, x-5   , y+22, 55, "Gain");
		obj.freq=knobCreate(f, x+70-5, y+22, 55, "Freq");
	}
	else
	{
		obj.line =gui.newPicture(f, x, y+6, 80,  2, "img/hline.png");
		obj.title=gui.newLabel(f, x+28, y, 24, 14, '', prop.value);
		obj.title.setProps({bgcolor: color.dblue});
		obj.title.setText(props.title);
	// 2 knobs with labels and values
		obj.gain=knobCreate(f, x   , y+17, 40, "GAIN");
		obj.freq=knobCreate(f, x+40, y+17, 40, "FREQ");
	}
	obj.v_gain=0;
	obj.v_freq=0;
	obj.a_gain=0;
	obj.a_freq=0;

	obj.t_gain=props.t_gain;
	obj.t_freq=props.t_freq;
	obj.name  =props.title;
	obj.frange=props.frange;

	obj.focus=function(on)
	{
		var pr=on?prop.Focused:prop.Inactive;
		var idx=on?1:0;
		var kidx=on?2:0;

		if('line' in this) this.line.setIndex(-1, idx); // XXX
		this.title.setProps(pr);
		this.gain.val.setProps(pr);
		this.gain.lbl.setProps(pr);
		this.gain.knob.setIndex(kidx);
		this.freq.val.setProps(pr);
		this.freq.lbl.setProps(pr);
		this.freq.knob.setIndex(kidx);
	}

	return obj;
}

function eqPageCreate(p)
{
	var eq_fr, eqbg_fr, band_fr;
	var key;
	var l;

	if(cfg_fusionUI)
	{
		p.subtitle=GUI_CreatePageSubTitle(p.frame, "EQ OPTIONS", "img/svg/icon_eq_ylw.svg", 25, 13);

		eq_fr=gui.newFrame(p.frame, 0, 93, 640, 224, "img/svg/eq_bg.svg");
		p.on =gui.newLabel(eq_fr, 162+173+30, 17, 95, 14, '', {font:fontSemiBold(10), color:color.lyellow, align:gui.CENTER, valign:gui.MIDDLE});
		l=gui.newLabel(eq_fr, 162+30, 17, 95, 14, '', {font:fontSemiBold(10), color:color.lgray, align:gui.CENTER, valign:gui.MIDDLE});
		l.setText("EQUALIZER");

	// graph
		const dx=25;

		eqbg_fr=gui.newFrame(eq_fr, 63, 54, 456, 121, "img/svg/surface_eq.svg");
		p.graph=gui.newEq(eqbg_fr, 0, 0, 455, 120, "");
		p.graph.setColor(color.lyellow);
		eqSetLogFreq(p.graph, 1, 455, 106, 150); //3rd and 4th calculated by mult orig Elem values * 455/243 size from Element
		p.graph.setdB(1, 120, 40, 39/15); //ys - y start , ye - y end, yc - y center, yscale - each unit size, imho

		p.x_labels={};
		const x_lab_def={
			"20":	[18+14+dx,	140+42],
			"40":	[58+20-2+dx,	140+42],
			"100":	[112+20+3+dx,	140+42],
			"400":	[203+20+2+dx,	140+42],
			"1k":	[269+20+dx,	140+42],
			"4k":	[359+20+dx,	140+42],
			"10k":	[413+20+dx,	140+42],
			"20k":	[458+20+5+dx,	140+42]
		};

		for(key in x_lab_def)
		{
			p.x_labels[key]=gui.newLabel(eq_fr, x_lab_def[key][0], x_lab_def[key][1], 23, 16, '', {font:fontLight(8), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
			p.x_labels[key].setText(key);
		}

		p.y_labels={};
		const y_lab_def={
			"+15dB":	[480+21+dx,	14+31],
			"-0":		[480+21+dx,	54+31],
			"-15dB":	[480+21+dx,	92+31],
			"-30dB":	[480+21+dx,	133+31]
		};

		for(key in y_lab_def)
		{
			p.y_labels[key]=gui.newLabel(eq_fr, y_lab_def[key][0], y_lab_def[key][1], 40, 16, '', {font:fontLight(8), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
			p.y_labels[key].setText(key);
		}

	// band controls
		band_fr=gui.newFrame(p.frame, 0, 93+232, 640, 110, "img/svg/eq_band_bg.svg");
		p.b=[];
		p.b[0]=eqPageBandCreate(band_fr, 68+20      , 15, {title:"LO" , t_gain:'wEQLG', t_freq:'wEQLF', frange: eq_range.f_lo });
		p.b[1]=eqPageBandCreate(band_fr, 68+20+180  , 15, {title:"MID", t_gain:'wEQMG', t_freq:'wEQMF', frange: eq_range.f_mid});
		p.b[2]=eqPageBandCreate(band_fr, 68+20+180*2, 15, {title:"HI" , t_gain:'wEQHG', t_freq:'wEQHF', frange: eq_range.f_hi });

		p.b[0].shelf=gui.newPicture(band_fr,  18, 45, 23, 20, "img/svg/shelf_edit_lo.svg");
		p.b[2].shelf=gui.newPicture(band_fr, 597, 45, 23, 20, "img/svg/shelf_edit_hi.svg");
	}
	else
	{
		eq_fr=gui.newFrame(p.frame, 31, 103, 356, 219, "img/eq_bg.png");
		p.on =gui.newLabel(eq_fr, 200, 10, 50, 14, '', prop.value_yellow);
		l=gui.newLabel(eq_fr, 60, 10, 100, 14, '', prop.value);
		l.setText("EQUALIZER");

	// graph
		p.graph=gui.newEq(eq_fr, 30, 32, 276, 82, "");
		eqSetLogFreq(p.graph, 1, 260, 61, 87);
		p.graph.setdB(1, 80, 27, 26/15);

	// band controls
		p.b=[];
		p.b[0]=eqPageBandCreate(eq_fr,  28, 143, {title:"LO" , t_gain:'wEQLG', t_freq:'wEQLF', frange: eq_range.f_lo });
		p.b[1]=eqPageBandCreate(eq_fr, 136, 143, {title:"MID", t_gain:'wEQMG', t_freq:'wEQMF', frange: eq_range.f_mid});
		p.b[2]=eqPageBandCreate(eq_fr, 244, 143, {title:"HI" , t_gain:'wEQHG', t_freq:'wEQHF', frange: eq_range.f_hi });

		p.b[0].shelf=gui.newPicture(eq_fr,   3, 175, 23, 20, "img/shelf_edit_lo.png");
		p.b[2].shelf=gui.newPicture(eq_fr, 329, 175, 23, 20, "img/shelf_edit_hi.png");
	}

	p.eqac=false; p.eqlm=false; p.eqhm=false;

	p.focus=-1;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
		if(this.focus in this.b) this.b[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.b) this.b[this.focus].focus(true);
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "LO GAIN", push: "BYPASS/\nACTIVE", enter: true},
		{enabled: true, rot: "LO FREQ"},
		{enabled: true, rot: "MID GAIN"},
		{enabled: true, rot: "MID FREQ"},
		{enabled: true, rot: "HI GAIN", push: "SHELF"},
		{enabled: true, rot: "HI FREQ", push: "EXIT", chopt: true}
	];
	p.sknobs3=
	[
		{enabled: false, rot: "GAIN", updn: true},
		{enabled: true,  rot: "FREQ", push: "BYPASS/\nACTIVE", jog: true, enter: true},
		{enabled: true,  rot: "FUNCTION", push: "EXIT", ltrt: true, chopt: true}
	];

// event functions
	p.onSoftKnobRot =eqPageOnSoftKnobRot;
	p.onSoftKnobDown=eqPageOnSoftKnobDown;
	p.onSoftKnobUp  =eqPageOnSoftKnobUp;
	p.onIndi=eqPageOnIndi;
}

function eqPageOnIndi(chmsg)
{
	var n, band;
	var changed=false;

	for(n=0; n<3; n++)
	{
		band=this.b[n];
		if(band.t_gain in chmsg)
		{
			band.v_gain=chmsg[band.t_gain];
			band.a_gain=knobSetValue(band.gain, band.v_gain, eq_range.gain);
			sknobsSetOne(n*2, {angleNrm: band.a_gain});
			if(this.focus==n)
				sknobsSetOne(6, {angleNrm: band.a_gain});
			changed=true;
		}
		if(band.t_freq in chmsg)
		{
			band.v_freq=chmsg[band.t_freq];
			band.a_freq=knobSetFreq(band.freq, band.v_freq, band.frange);
			sknobsSetOne(n*2+1, {angleNrm: band.a_freq});
			if(this.focus==n)
				sknobsSetOne(7, {angleNrm: band.a_freq});
			changed=true;
		}
	}
	if('bEQAC' in chmsg)
	{
		this.eqac=(chmsg.bEQAC==1); // 1 - EQ on
		this.on.setText(this.eqac?"ACTIVE":"BYPASS");
		changed=true;
	}
	if('bEQLM' in chmsg)
	{
		this.eqlm=(chmsg.bEQLM==1); // 1-shelf, 2-pass
		this.b[0].shelf.setIndex(this.eqlm?0:1);
		changed=true;
	}
	if('bEQHM' in chmsg)
	{
		this.eqhm=(chmsg.bEQHM==1); // 1-shelf, 2-pass
		this.b[2].shelf.setIndex(this.eqhm?0:1);
		sknobsSetOne(4, {push: this.eqhm?"SHELF":"PEAK"});
		if(this.focus==2)
			sknobsSetOne(6, {push: this.eqhm?"HI SHELF":"HI PEAK"});
		changed=true;
	}

	if(changed)
	{
		if(this.eqac)
			this.graph.setParams(this.b[0].v_freq, this.b[1].v_freq, this.b[2].v_freq, this.b[0].v_gain/10, this.b[1].v_gain/10, this.b[2].v_gain/10, this.eqlm, this.eqhm);
		else
			this.graph.setParams(0, 0, 0, 0, 0, 0, false, false);
	}
}

function eqPageOnSoftKnobRot(idx, delta)
{
	var msg={id:'WRIN'};
	var n, band;

	idx--; // fixme

	if(idx==8)
	{
	// change focus
		this.setFocus(clamp(this.focus+delta, 0, 2));
		sknobsSetOne(8, {angleNrm: this.focus/2});
		band=this.b[this.focus];
		sknobsSetOne(6, {enabled: true, rot: band.name+" GAIN", push:this.focus==2?(this.eqhm?"HI SHELF":"HI PEAK"):null, angleNrm: band.a_gain});
		sknobsSetOne(7, {enabled: true, rot: band.name+" FREQ", angleNrm: band.a_freq});
		return;
	}

	if(idx>=0 && idx<=5)
		n=idx>>1;
	else
		n=this.focus;

	if(n in this.b)
	{
		band=this.b[n];

		if(idx&1) // Frequency
		{
			msg[band.t_freq]=clamp(band.v_freq+delta*band.frange.step, band.frange.min, band.frange.max);
		}
		else // Gain
		{
			msg[band.t_gain]=clamp(band.v_gain+delta*eq_range.gain.step, eq_range.gain.min, eq_range.gain.max);
			if(n==0) msg.bEQLM=msg.wEQLG<0?1:2; // low mode is automatic: FIXME: this probably should be done @ engine side
		}
		host.sendNestCmsg(this.maintag, msg);
	}
}
function eqPageOnSoftKnobDown(idx)
{
	switch(idx)
	{
	case 8:
	case 1: // active / bypass
		host.sendNestCmsg(this.maintag, {id:"WRIN", bEQAC: this.eqac?0:1});
		break;
	case 7:
		if(this.focus!=2) return;
		/* fall through */
	case 5: // hi shelf
		host.sendNestCmsg(this.maintag, {id:"WRIN", bEQHM: this.eqhm?2:1});
		break;
	}
}
function eqPageOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 6:
	case 9: // Combo3
		if(('channel' in this) && this.channel!=null)
			chSwitchToPage(this); // will effectively go back to chopt page
		else
			closePage(this, null);
		break;
	}
}

// ------------------------ channel eq page ------------------------

function cheqPageCreate()
{
	var p=Page_Create('cheq', 'chn', "");
	p.hppage=false;
	p.maintag='mCHxx';
	p.onOpen =cheqOnOpen;
	p.onClose=cheqOnClose;
	eqPageCreate(p);
}

function cheqOnOpen(channel_nr)
{
	if(channel_nr==null) return;
	this.channel=channel_nr;
// Indications
	this.title.setChannel(this.channel);
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 255);
	mod.setChnFusionInvert(this.channel, 1);
	mod.setMasterKeyLed(keys.MstChnEq, 255);
// Register receive msg handlers
	rxHandlersCh[this.channel].cheq=this;

	this.maintag=txtChn[this.channel];

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.setFocus(-1);
	sknobsSetOne(8, {angle: 180});
	sknobsSetOne(6, {angleNrm: 0});
	sknobsSetOne(7, {angleNrm: 0});

	var rmsg=host.sendChnCmsgRq(this.channel, {id:"READ",
		bEQTY:0, bEQAC:0, bEQHM:0, bEQLM:0, bEQHF:0,
		bEQMF:0, bEQLF:0, bEQHG:0, bEQMG:0, bEQLG:0
	});
	if(rmsg!=null) this.onIndi(rmsg);
}
function cheqOnClose()
{
	sknobsHide();

//delete receive msg handlers
	delete rxHandlersCh[this.channel].cheq;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setChnFusionInvert(this.channel, 0);
	mod.setMasterKeyLed(keys.MstChnEq, 0);
}

// ------------------------ global hpeq page ------------------------
function hpeqPageCreate()
{
	var p=Page_Create('hpeq', 'mon', "H/P PROCESS");
	p.maintag='mCRHP';
	p.hppage=true;
	p.onOpen =hpeqOnOpen;
	p.onClose=hpeqOnClose;
	eqPageCreate(p);
}

function hpeqOnOpen(channel_nr)
{
// Indications
	mod.setMasterKeyLed(keys.MstMonOpt, 255);
	mod.setMasterKeyLed(keys.CmbMonOpt, 255);
// register receive msg handlers
	rxHandlersGlobal.hpeqIndi=hpeqIndi;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.setFocus(-1);
	sknobsSetOne(8, {angle: 180});
	sknobsSetOne(6, {angleNrm: 0});
	sknobsSetOne(7, {angleNrm: 0});

	var rmsg=host.sendNestCmsgRq('mCRHP', {id:"READ",
		bEQTY:0, bEQAC:0, bEQHM:0, bEQLM:0, bEQHF:0,
		bEQMF:0, bEQLF:0, bEQHG:0, bEQMG:0, bEQLG:0
	});
	if(rmsg!=null) this.onIndi(rmsg);
}
function hpeqOnClose()
{
	sknobsHide();

// delete receive msg handlers
	delete rxHandlersGlobal.hpeqIndi;

	mod.setMasterKeyLed(keys.MstMonOpt, 0);
	mod.setMasterKeyLed(keys.CmbMonOpt, 0);
}
function hpeqIndi(msg)
{
	if('mCRHP' in msg) pages.hpeq.onIndi(msg.mCRHP);
}
