// ------------------------ channel pan page ------------------------
function chm1PageCreate()
{
	var p;
	var f, l;

	p=Page_Create('chm1', 'chn', "");
	f=p.frame;

	if(cfg_fusionUI)
	{
		p.subtitle=GUI_CreatePageSubTitle(f, "FEED TO SOURCE", "img/svg/icon_feed_to_source_ylw.svg", 24, 12);

		p.fr=gui.newFrame(f, 0, 93, 640, 350, "img/svg/ch_edit_m1_bg.svg");

		GUI_createSmallMeter(p.fr, 585, 39, mtrGUI.ch_feed);

		p.error=gui.newLabel(p.fr,  640/2-300/2, 100+200+10, 300, 19, '', prop.src);
		l=gui.newLabel(p.fr, 640/2-150/2-250+100,  20+10+19/2, 250, 19, '', {font:fontRegular(12), color:color.white, align:gui.RIGHT, valign:gui.MIDDLE});
		l.setText("CURRENT BACKFEED: ");
		p.fsrc =gui.newLabel   (p.fr, 640/2-150/2+100+5,  20+10, 150, 19*2, '', {font:fontRegular(12), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
		p.auto=gui.newFrame    (p.fr, 640/2-52/2-5, 41+5+10+19/2, 52, 16, '');
		p.auto.lbl=gui.newLabel(p.auto, 0, 0, 40, 16, '', {font:fontSemiBold(8), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
		p.auto.lbl.setText("AUTO");
		p.auto.led=gui.newPicture(p.auto, 40, 3, 12, 12, "img/svg/led_12px.svg");
		p.list =gui.newList   (p.fr,  640/2-620/2,  100, 620, 200-16, '', prop.list);
		p.list.setProp('border', 1);

		p.auto.setMode=function(mode){this.led.setIndex(mode==4?1:0);};

		p.knob_bfdg={};
		p.knob_bfdg.val=0;
		p.knob_bfdg.val_text=gui.newLabel  (p.fr, 10+5, 15, 70, 14, '', prop.value);
		p.knob_bfdg.vol_knob=gui.newKnob   (p.fr, 10+18+5, 14+15, 30, 30, "img/svg/knob_30px.svg");
		p.knob_bfdg.caption =gui.newLabel(p.fr, 10, 14+30+5+15, 85, 30, "", {font:fontSemiBold(8), color:color.lyellow, align:gui.CENTER, valign:gui.TOP});
		p.knob_bfdg.caption.setText("DIM DURING\nTALKBACK");
	}
	else
	{
		p.fr=gui.newFrame(f, 32, 103, 353, 329, "img/ch_edit_m1_bg.png");

		GUI_createSmallMeter(p.fr, 329, 38, mtrGUI.ch_feed);

		p.error=gui.newLabel  (p.fr,  24, 100, 290,  19, '', prop.src);
		p.fsrc =gui.newLabel  (p.fr, 179,  12, 150,  38, '', prop.feed);
		p.auto =gui.newPicture(p.fr, 237,  50,  34,  11, "img/auto.png");
		p.list =gui.newList   (p.fr,  55,  66, 214, 150, '', prop.list);
		p.list.setProp('border', 1);

		p.auto.setMode=function(mode){this.setIndex(mode==4?0:1);};

		p.knob_bfdg={};
		p.knob_bfdg.val=0;
		p.knob_bfdg.val_text=gui.newLabel  (p.fr, 200, 220, 70, 14, '', prop.value);
		p.knob_bfdg.vol_knob=gui.newKnob   (p.fr, 218, 235, 26, 26, "img/knob_26px.png");
		p.knob_bfdg.caption =gui.newPicture(p.fr, 200, 261, 70, 30, "img/ch_edit_m1_knob.png");
	}
	p.error.hide();
	p.list.insert("Auto (Program 1 / Phone)", 4);
	p.list.insert("Program 1", 1);
	p.list.insert("Program 2", 2);
	p.list.insert("Program 3", 5);
	p.list.insert("Program 4", 6);
	p.list.insert("Phone",     3);
	p.list.insert("AUX Send A", 7);
	p.list.insert("AUX Send B", 8);
	p.list.insert("AUX Send C", 9);
	p.list.insert("AUX Send D", 10);

	p.enabled=false;

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "SELECT", push: "TAKE", list: p.list, updn: true, jog: true, enter: true, knob: true},
		{enabled: true, rot: "DIM", push: "OFF"},
		{enabled: false},
		{enabled: false},
		{enabled: false},
		{enabled: true, push: "EXIT", chopt: true}
	];
	p.sknobs3=
	[
		{enabled: true, rot: "SELECT", push: "TAKE", list: p.list, updn: true, jog: true, enter: true, knob: true},
		{enabled: true, rot: "DIM", push: "OFF"},
		{enabled: true, push: "EXIT", chopt: true}
	];

// locals
	p.knobUsed=false;
// event functions
	p.onOpen =chm1OnOpen;
	p.onClose=chm1OnClose;
	p.onIndi =chm1Indi;
	p.onSoftKnobUp  =chm1OnSoftKnobUp;
	p.onSoftKnobRot =chm1OnSoftKnobRot;
	p.onKnobRot     =function(){this.knobUsed=true;};
	p.onChoptUp     =function(){this.onSoftKnobUp(this.knobUsed?1:6); if(this.knobUsed) closePage(this, this.channel);}
}
function chm1OnOpen(channel_nr)
{
	if(channel_nr==null) return;
	this.channel=channel_nr;
// Indications
	this.title.setChannel(this.channel);
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 255);
	mod.setChnFusionInvert(this.channel, 1);
	mod.setMasterKeyLed(keys.MstChnM1, 255);
// Register receive msg handlers
	rxHandlersCh[this.channel].chm1=this;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.knobUsed=false;
// request meters
	chnRequestMeter(this.channel, mtrEng.chnFeed, mtrGUI.ch_feed, true);
	var rmsg=host.sendChnCmsgRq(channel_nr, {id:"READ", bFSMO:0, bSRCT:0, bBFST:0, bBFEN:0, bBFDG:0});
	if(rmsg!=null) this.onIndi(rmsg);
}
function chm1OnClose()
{
	sknobsHide();
// release meters
	chnRequestMeter(this.channel, mtrEng.chnFeed, mtrGUI.ch_feed, false);
// delete receive msg handlers
	delete rxHandlersCh[this.channel].chm1;
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setChnFusionInvert(this.channel, 0);
	mod.setMasterKeyLed(keys.MstChnM1, 0);
}
function chm1Indi(chmsg)
{
	var angle, val, sk_on={enabled:true},sk_off={enabled:false};

	if('bBFEN' in chmsg)
	{
		if(chmsg.bBFEN==0)
		{
			this.fsrc.hide();
			this.auto.hide();
			this.list.hide();
			this.knob_bfdg.val_text.hide();
			this.knob_bfdg.caption.hide();
			this.knob_bfdg.vol_knob.hide();
			this.error.setText("BACK FEED DISABLED");
			this.error.show();

			this.enabled=false;
			sknobsSet({0:sk_off, 1:sk_off, 6:sk_off, 7: sk_off});
		}
		else if(chmsg.bBFEN==1) // Backfeed with control
		{
			this.error.hide();
			this.fsrc.show();
			this.auto.show();
			this.list.show();
			this.knob_bfdg.val_text.show();
			this.knob_bfdg.caption.show();
			this.knob_bfdg.vol_knob.show();

			this.enabled=true;
			sknobsSet({0:sk_on, 1:sk_on, 6:sk_on, 7: sk_on});
		}
		else if(chmsg.bBFEN==2) // Backfeed with only dim gain control (Mics)
		{
			this.error.hide();
			this.fsrc.show();
			this.auto.hide();
			this.list.hide();
			this.knob_bfdg.val_text.show();
			this.knob_bfdg.caption.show();
			this.knob_bfdg.vol_knob.show();

			this.enabled=true;
			sknobsSet({0:sk_off, 1:sk_on, 6:sk_off, 7: sk_on});
		}
		else // Backfeed without control (Flexible)
		{
			this.error.hide();
			this.fsrc.show();
			this.auto.hide();
			this.list.hide();
			this.knob_bfdg.val_text.hide();
			this.knob_bfdg.caption.hide();
			this.knob_bfdg.vol_knob.hide();

			this.enabled=true;
			sknobsSet({0:sk_off, 1:sk_off, 6:sk_off, 7: sk_off});
		}
		this.list.select(0);
	}
	if(('bFSMO' in chmsg) && this.enabled)
	{
	// if auto
		this.auto.setMode(chmsg.bFSMO);
		setListActive(this.list, chmsg.bFSMO);
	}
	if(('wBFST' in chmsg) && this.enabled) this.fsrc.setText(get_bfst_text(chmsg.wBFST)); // New flexible logic
	if(('wBFDG' in chmsg) && this.enabled)
	{
		this.knob_bfdg.val=chmsg.wBFDG;
		if(this.knob_bfdg.val==-32768) // OFF
		{
			angle=0;
			val="OFF";
		}
		else
		{
			angle=(this.knob_bfdg.val+300)/300;
			val=host.sprintf("%.1f dB", this.knob_bfdg.val/10);
		}

		this.knob_bfdg.vol_knob.setAngleNrm(angle);
		sknobsSetTwo(1, 7, {angleNrm: angle});
		this.knob_bfdg.val_text.setText(val);
	}
	sknobsUpdate();
}
function chm1OnSoftKnobRot(idx, delta)
{
	if(!this.enabled) return;
	if(idx==2 || idx==8)
	{
		var new_gain=clamp(this.knob_bfdg.val+(delta*5), -300, 0);
		host.sendChnCmsg(this.channel, {id:"WRIN", wBFDG: new_gain});
	}
}
function chm1OnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 1:
	case 7:
		if(this.enabled) host.sendChnCmsg(this.channel, {id:"WRIN", bFSMO:this.list.selId});
		break;
	case 2:
	case 8:
		if(this.enabled) host.sendChnCmsg(this.channel, {id:"WRIN", wBFDG:-32768});
		break;
	case 6:
	case 9: // Combo3
		chSwitchToPage(this); // will effectively go back to chopt page
		break;
	}
}
