// ------------------------ channel option page ------------------------

function choptCreateSource(frm)
{
	var obj={id:'chsrc'};

	if(cfg_fusionUI)
	{
		obj.frame=gui.newFrame(frm, 0, 40, 206, 92, "img/svg/ch_opt_frame.svg");
		obj.icon =gui.newFrame(obj.frame, 206-10-20, 6, 20, 12, "img/svg/icon_source.svg");
		obj.type =gui.newLabel(obj.frame, 12,  5, 160, 16, '', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		obj.name =gui.newLabel(obj.frame, 12, 28, 164, 24, '', {font:fontSemiBold(14), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
		obj.stat =gui.newLabel(obj.frame, 12, 58, 182, 14, '', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		obj.owner=gui.newLabel(obj.frame, 12, 74, 182, 14, '', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		GUI_createSmallMeter(obj.frame, 178, 24, mtrGUI.chopt_src);
		obj.focus=function(on)
		{
			var bg=on?"img/svg/ch_opt_frame_on.svg":"img/svg/ch_opt_frame.svg";
			this.frame.setBg(bg);
		};
		obj.setType=function(type){this.type.setText("Current Source: "+((type in srct_txt)?srct_txt[type]:""));};
	}
	else
	{
		obj.frame=gui.newFrame(frm, 50, 52, 152, 77, "img/chopt_source.png");
		obj.name =gui.newLabel(obj.frame, 10, 29, 110, 19, '', prop.src);
		obj.type =gui.newLabel(obj.frame, 39, 15,  76, 14, '', prop.value_left);
		obj.stat =gui.newLabel(obj.frame, 13, 48, 133, 14, '', prop.value_left);
		obj.owner=gui.newLabel(obj.frame, 13, 62, 133, 14, '', prop.value_left);
		GUI_createSmallMeter(obj.frame, 122, 23, mtrGUI.chopt_src);
		obj.focus=function(on)
		{
			var bg=on?"img/chopt_source_sel.png":"img/chopt_source.png";
			var pr=on?prop.ChoptFocused:prop.ChoptInactive;

			this.frame.setBg(bg);
			this.type.setProps(pr);
			this.stat.setProps(pr);
			this.owner.setProps(pr);
		};
		obj.setType=function(type){this.type.setText((type in srct_txt)?srct_txt[type]:"");};
	}

	obj.src_state=sstat.error;
	obj.src_owner="";
	obj.src_fader=0;

	obj.indi=function(msg)
	{
		var update=false;

		if('bvSRCN' in msg) this.name.setText(host.arrtostr(msg.bvSRCN));
		if( 'bSRCT' in msg)
		{
			if(msg.bSRCT==srct.idle)
			{
				this.stat.hide();
				this.owner.hide();
			}
			else
			{
				this.stat.show();
				this.owner.show();
			}
			this.setType(msg.bSRCT);
		}

		if('sSCON' in msg) {this.src_owner=msg.sSCON; update=true;}
		if('bSCFN' in msg) {this.src_fader=msg.bSCFN; update=true;}
		if('bSRCS' in msg) {this.src_state=msg.bSRCS; update=true;}
		if(update) this.updateSharingInfo();
	};
	obj.updateSharingInfo=function()
	{
		var status=null, owner="";
		switch(this.src_state)
		{
		case sstat.listenonly:
			status="LISTEN ONLY";
			owner=this.src_owner;
			if(this.src_fader>0) owner=(this.src_fader+": ")+owner;
			break;
		case sstat.full_control:
			status="FULL CONTROL";
			owner="THIS FADER";
			break;
		case sstat.full_control_no_bf:
			status="FULL CONTROL NO BF";
			owner="THIS FADER";
			break;
		case sstat.locked_elsewhere:
			status="LISTEN ONLY";
			owner=this.src_owner;
			if(this.src_fader>0) owner=(this.src_fader+": ")+owner;
			break;
		case sstat.listenonly_lock_err:
			status="LISTEN ONLY (LOCK ERROR)";
			owner=this.src_owner;
			if(this.src_fader>0) owner=(this.src_fader+": ")+owner;
			break;
		}
		if(status==null)
		{
			this.stat.hide();
			this.owner.hide();
		}
		else
		{
			this.stat.setText(status);
			this.stat.show();
			this.owner.setText("Owner: "+owner);
			this.owner.show();
		}
	};
	obj.setSharingInfo=function(status, owner, fader)
	{
		this.src_state=status;
		this.src_owner=owner;
		this.src_fader=fader;
		this.updateSharingInfo();
	};

	return obj;
}
function choptCreateAutoMix(frm)
{
	var obj={id:'chamix'};

	if(cfg_fusionUI)
	{
		obj.frame=gui.newFrame(frm, 217, 40, 206, 92, "img/svg/ch_opt_frame.svg");
		obj.icon =gui.newFrame(obj.frame, 206-10-20, 6, 20, 12, "img/svg/icon_source.svg");
		obj.label=gui.newLabel(obj.frame, 12, 5, 96, 16, '', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		obj.label.setText("Automix");
		obj.amen =gui.newLabel(obj.frame, 12, 28, 164, 24, '', {font:fontSemiBold(14), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
		obj.prlbl=gui.newLabel(obj.frame, 12, 60, 90, 16, '', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.BOTTOM});
		obj.prlbl.setText("Weight Value:");
		obj.prval=gui.newLabel(obj.frame, 102, 52, 24, 24, '', {font:fontSemiBold(12), color:color.lyellow, align:gui.RIGHT, valign:gui.BOTTOM});
		obj.focus=function(on)
		{
			var bg=on?"img/svg/ch_opt_frame_on.svg":"img/svg/ch_opt_frame.svg";
			this.frame.setBg(bg);
		};
	}
	else
		return null;

	obj.indi=function(msg)
	{
		if('bAMEN' in msg) this.amen.setText((msg.bAMEN==1)?"ENABLED":"DISABLED");
		if('bAMWG' in msg) this.prval.setText(msg.bAMWG+" ");
	};

	return obj;
}
function choptCreateFeed(frm)
{
	var obj={id:'chm1'};

	if(cfg_fusionUI)
	{
		obj.frame=gui.newFrame(frm, 640-206, 40, 206, 92, "img/svg/ch_opt_frame.svg");
		obj.icon=gui.newFrame(obj.frame, 206-10-24, 6, 24, 12, "img/svg/icon_feed_to_source.svg");

		obj.label=gui.newLabel(obj.frame, 12, 5, 96, 16, '', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		obj.label.setText("Feed to Source");

		obj.name=gui.newLabel(obj.frame, 12, 24, 164, 30*2, '', {font:fontSemiBold(14), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
		obj.auto=gui.newFrame(obj.frame, 112, 5, 46, 16, '');
		obj.auto.label=gui.newLabel(obj.auto, 0, 0, 30, 14, 'Auto', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		obj.auto.label.setText("Auto");
		obj.auto.led=gui.newPicture(obj.auto, 30, 5, 6, 6, "img/svg/led_auto.svg");
		obj.auto.setMode=function(mode){this.led.setIndex(mode==4?1:0);};

		GUI_createSmallMeter(obj.frame, 178, 24, mtrGUI.chopt_feed);
		obj.focus=function(on)
		{
			var bg=on?"img/svg/ch_opt_frame_on.svg":"img/svg/ch_opt_frame.svg";
			this.frame.setBg(bg);
		};
	}
	else
	{
		obj.frame=gui.newFrame(frm, 214, 52, 152, 77, "img/chopt_feed.png");
		obj.name =gui.newLabel  (obj.frame, 10, 20, 110, 19*2, '', prop.feed);
		obj.auto =gui.newPicture(obj.frame, 15, 58,  35, 8, "img/led_auto.png");
		obj.auto.setMode=function(mode){this.setIndex(mode==4?1:0);};
		GUI_createSmallMeter(obj.frame, 122, 23, mtrGUI.chopt_feed);

		obj.focus=function(on)
		{
			var bg=on?"img/chopt_feed_sel.png":"img/chopt_feed.png";
			var idx=on?1:0;

			this.frame.setBg(bg);
			this.auto.setIndex(-1, idx);
		};
	}

	obj.indi=function(msg)
	{
		if('bBFEN' in msg) this.auto.show(msg.bBFEN==1);
		if('wBFST' in msg) this.name.setText(get_bfst_text(msg.wBFST));
		if('bFSMO' in msg) this.auto.setMode(msg.bFSMO);
	};

	return obj;
}
function choptCreateEq(frm)
{
	var obj={id:'cheq'};
	var key;

	if(cfg_fusionUI)
	{
		obj.frame=gui.newFrame(frm, 0, 142, 640, 165, "img/svg/chopt_eq.svg");
		obj.label=gui.newLabel(obj.frame, 12, 5, 30, 15, '', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		obj.label.setText("Eq");
		obj.icon=gui.newFrame(obj.frame, 640-10-25, 6, 25, 13, "img/svg/icon_eq.svg");

		obj.eqbg=gui.newFrame(obj.frame, 18+20, 20, 456, 121, "img/svg/surface_eq.svg");

		obj.graph=gui.newEq(obj.eqbg, 0, 0, 455, 120, "");
		obj.graph.setColor(color.lyellow);
		eqSetLogFreq(obj.graph, 1, 455, 106, 150); //3rd and 4th calculated by mult orig Elem values * 455/243 size from Element
		obj.graph.setdB(1, 120, 40, 39/15); //ys - y start , ye - y end, yc - y center, yscale - each unit size, imho

		obj.x_labels={};
		const y=142;
		const x_lab_def={
			"20":	[18+14,	y],
			"40":	[58+20-2,	y],
			"100":	[112+20+3,y],
			"400":	[203+20+2,y],
			"1k":	[269+20,y],
			"4k":	[359+20,y],
			"10k":	[413+20+4,y],
			"20k":	[458+20+5,y]
		};

		for(key in x_lab_def)
		{
			obj.x_labels[key]=(gui.newLabel(obj.frame, x_lab_def[key][0], x_lab_def[key][1], 23, 16, '', {font:fontLight(8), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE}));
			obj.x_labels[key].setText(key);
		}

		obj.y_labels={};
		const y_lab_def={
			"+15dB":	[480+21,	14],
			"-0":		[480+21,	54],
			"-15dB":	[480+21,	92],
			"-30dB":	[480+21,	130]
		};

		for(key in y_lab_def)
		{
			obj.y_labels[key]=(gui.newLabel(obj.frame, y_lab_def[key][0], y_lab_def[key][1], 40, 16, '', {font:fontLight(8), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE}));
			obj.y_labels[key].setText(key);
		}

		obj.focus=function(on)
		{
			var bg=on?"img/svg/chopt_eq_sel.svg":"img/svg/chopt_eq.svg";

			this.frame.setBg(bg);
		};
	}
	else
	{
		obj.frame=gui.newFrame(frm, 49, 137, 317, 111, "img/chopt_eq.png");
		obj.graph=gui.newEq(obj.frame, 25, 12, 243, 77, '');
		eqSetLogFreq(obj.graph, 1, 241, 57, 80);
		obj.graph.setdB(1, 76, 25, 24/15);
		obj.focus=function(on)
		{
			var bg=on?"img/chopt_eq_sel.png":"img/chopt_eq.png";

			this.frame.setBg(bg);
		};
	}

	obj.values={lf:0, mf:0, hf:0, lg:0, mg:0, hg:0, lm:false, hm:false, ac:false};
	obj.indi=function(msg)
	{
		var upd=false;
		var p=this.values;

		if('wEQLF' in msg) {upd=true; p.lf=msg.wEQLF;}
		if('wEQMF' in msg) {upd=true; p.mf=msg.wEQMF;}
		if('wEQHF' in msg) {upd=true; p.hf=msg.wEQHF;}
		if('wEQLG' in msg) {upd=true; p.lg=msg.wEQLG/10;}
		if('wEQMG' in msg) {upd=true; p.mg=msg.wEQMG/10;}
		if('wEQHG' in msg) {upd=true; p.hg=msg.wEQHG/10;}
		if('bEQLM' in msg) {upd=true; p.lm=(msg.bEQLM==1);}
		if('bEQHM' in msg) {upd=true; p.hm=(msg.bEQHM==1);}
		if('bEQAC' in msg) {upd=true; p.ac=(msg.bEQAC==1);}
		if(upd)
		{
			if(p.ac)
				this.graph.setParams(p.lf, p.mf, p.hf, p.lg, p.mg, p.hg, p.lm, p.hm);
			else
				this.graph.setParams(0, 0, 0, 0, 0, 0, false, false);
		}
	};

	return obj;
}
function choptCreatePan(frm)
{
	var obj={id:'chpan'};

	if(cfg_fusionUI)
	{
		obj.frame=gui.newFrame(frm, 0, 317, 312, 127, "img/svg/ch_opt_pan_bg.svg");
		obj.surface=gui.newFrame(obj.frame, 296/2-182/2+4, 50-10, 182, 81, "img/svg/surface_pan.svg");
		obj.ctpan=gui.newPan(obj.surface, 0, 0, 180, 81, '');
		obj.ctpan.setParams(85, 70, "img/svg/pan_ball.svg");
		obj.radius=60;
		obj.adelta=180/25;

		obj.icon=gui.newFrame(obj.frame, 312-10-20, 6, 20, 20, "img/svg/icon_pan_and_mode.svg");

		obj.label=gui.newLabel(obj.frame,  12,  5, 90, 16, '', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		obj.mode =gui.newLabel(obj.frame,   6, 87, 54, 30, '', {font:fontSemiBold(8), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		obj.phase=gui.newLabel(obj.frame, 243, 87, 51, 30, '', {font:fontSemiBold(8), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});

		obj.label.setText("Pan & Mode");

		obj.focus=function(on)
		{
			var bg=on?"img/svg/ch_opt_pan_bg_on.svg":"img/svg/ch_opt_pan_bg.svg";

			this.frame.setBg(bg);
		};
	}
	else
	{
		obj.frame=gui.newFrame(frm, 50, 257, 152, 111, "img/chopt_pan.png");
		obj.ctpan=gui.newPan(obj.frame, 27, 23, 93, 58, '');
		obj.ctpan.setParams(48, 52, "img/pan_ball.png");
		obj.radius=37;
		obj.adelta=180/25;
		obj.mode =gui.newLabel(obj.frame, 10, 82, 78, 26, '', prop.value);
		obj.phase=gui.newLabel(obj.frame, 88, 82, 50, 26, '', prop.value);
	// FIXME: when stereo pan @ -90 or 90 half of a ball is cut
		obj.focus=function(on)
		{
			var bg=on?"img/chopt_pan_sel.png":"img/chopt_pan.png";
			var pr=on?prop.ChoptFocused:prop.ChoptInactive;

			this.frame.setBg(bg);
			this.mode .setProps(pr);
			this.phase.setProps(pr);
		};
	}

	obj.values={src_stereo: false, mode: mode_type.stereo, pan: [0,0], phase: 1};
	obj.indi=function(msg)
	{
		var upd=false;
		var p=this.values;

		if( 'bSRCT' in msg) {p.src_stereo=srcIsStereo(msg.bSRCT); upd=true;}
		if( 'bMODE' in msg) {p.mode =msg.bMODE; upd=true;}
		if( 'bPHAS' in msg) {p.phase=msg.bPHAS; upd=true;}
		if('wvPANO' in msg) {p.pan[0]=msg.wvPANO[0]; p.pan[1]=msg.wvPANO[1]; upd=true;}
		if(upd)
		{
			var idx=panGetIdx(p.pan[0], p.pan[1]);
			var angle=-90+idx/pan_const.val_table_maxind*180;

			this.phase.setText(get_phase_name(p.mode, p.phase)+"\nPHASE");
			this.mode.setText(((p.mode in mode_txt)?mode_txt[p.mode]:"")+"\nMODE");
			if(p.src_stereo && p.mode==mode_type.stereo)
				this.ctpan.setValues(this.radius, this.radius, angle-this.adelta, angle+this.adelta);
			else
				this.ctpan.setValues(this.radius, -1, angle, 0);
		}
	};

	return obj;
}
function choptCreateMicproc(frm)
{
	var obj={id:'chmicproc'};
	var mark;

	if(cfg_fusionUI)
	{
		obj.frame=gui.newFrame(frm, 640-312, 317, 312, 127, "img/svg/ch_opt_pan_bg.svg");
		obj.icon=gui.newFrame(obj.frame, 312-10-25, 6, 25,13, "img/svg/icon_dynamics.svg");
		obj.label=gui.newLabel(obj.frame, 12, 5, 90, 16, '', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		obj.label.setText("Dynamics");

		const y=-1;
		var dyn_bar_def;
		const dyn_bar_def_gate_n_comp={
			"- 0" : [0, y+36+1],
			"- 10": [0, y+36+20],
			"- 20": [0, y+36+40],
			"- 30": [0, y+36+60-1]
		};
		const dyn_bar_def_dess={
			"- 0" : [0, y+36+1],
			"- 10": [0, y+36+30],
			"- 20": [0, y+36+60-1]
		};
		const dyn_bar_labels=["GATE","COMP","D-ES"];

		obj.bars=[];
		for(var i=0;i<3;i++)
		{
			obj.bars[i]=gui.newFrame(obj.frame, 45+75*i, 36, 28, 60, "img/svg/bar_dyn.svg");
			obj.bars[i].label=gui.newLabel(obj.frame, 45+75*i, 36+61+4, 40, 15, '', {font:fontSemiBold(8), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
			obj.bars[i].label.setText(dyn_bar_labels[i]);
			obj.bars[i].marks={};

			if(dyn_bar_labels[i]==="D-ES")
				dyn_bar_def=dyn_bar_def_dess;
			else
				dyn_bar_def=dyn_bar_def_gate_n_comp;

			for(mark in dyn_bar_def)
			{
				obj.bars[i].marks[mark]=gui.newLabel(obj.frame, 45+75*i+28+4, dyn_bar_def[mark][1]-9, 30, 15, '', {font:fontSemiBold(8), color:color.white, align:gui.LEFT, valign:gui.TOP});
				obj.bars[i].marks[mark].setText(mark);
			}
		}

		obj.mtrexp =gui.newMeter(obj.bars[0],  0, 0, 28, 60, "img/svg/bar_dyn_ylw.svg");
		obj.mtrcomp=gui.newMeter(obj.bars[1],  0, 0, 28, 60, "img/svg/bar_dyn_ylw.svg");
		obj.mtrdess=gui.newMeter(obj.bars[2],  0, 0, 28, 60, "img/svg/bar_dyn_ylw.svg");
		obj.mtrfrze=gui.newMeter(obj.frame,  45+75*1+28/2-16/2, 36-16, 16, 16, "img/svg/mtr_freeze.svg"); //should be above mtr comp
		obj.mtrexp .setBars(15); obj.mtrexp .setPoints([-300, 15, 0, 0]); obj.mtrexp .setDir(1);
		obj.mtrcomp.setBars(15); obj.mtrcomp.setPoints([-300, 15, 0, 0]); obj.mtrcomp.setDir(1);
		obj.mtrdess.setBars(15); obj.mtrdess.setPoints([-200, 15, 0, 0]); obj.mtrdess.setDir(1);
		obj.mtrfrze.setBars( 1); obj.mtrfrze.setPoints([0, 0, 1, 1]);
		//TODO FIXME the one pixel yellow bar which appears on initial drawing of mtrexp,mtrcomp,mtrdess but disappears on focus

		obj.focus=function(on)
		{
			var bg=on?"img/svg/ch_opt_pan_bg_on.svg":"img/svg/ch_opt_pan_bg.svg";

			this.frame.setBg(bg);
		};
	}
	else
	{
		obj.frame=gui.newFrame(frm, 214, 256, 153, 111, "img/chopt_micproc.png");
		obj.mtrexp =gui.newMeter(obj.frame,  25, 34, 15, 60, "img/mtr_dyn.png");
		obj.mtrcomp=gui.newMeter(obj.frame,  63, 34, 15, 60, "img/mtr_dyn.png");
		obj.mtrdess=gui.newMeter(obj.frame, 101, 34, 15, 60, "img/mtr_dyn.png");
		obj.mtrfrze=gui.newMeter(obj.frame,  65, 21, 11, 11, "img/mtr_freeze.png");
		obj.mtrexp .setBars(30); obj.mtrexp .setPoints([-300, 30, 0, 0]); obj.mtrexp .setDir(1);
		obj.mtrcomp.setBars(30); obj.mtrcomp.setPoints([-300, 30, 0, 0]); obj.mtrcomp.setDir(1);
		obj.mtrdess.setBars(20); obj.mtrdess.setPoints([-200, 20, 0, 0]); obj.mtrdess.setDir(1);
		obj.mtrfrze.setBars( 1); obj.mtrfrze.setPoints([0, 0, 1, 1]);

		obj.focus=function(on)
		{
			var bg=on?"img/chopt_micproc_sel.png":"img/chopt_micproc.png";

			this.frame.setBg(bg);
		};
	}
	gui.createMeter(mtrGUI.chopt_mic, 6, null, [obj.mtrexp, obj.mtrcomp, obj.mtrdess, obj.mtrfrze]);

	obj.indi=function(msg)
	{
	};

	return obj;
}
function choptCreateSends(frm)
{
	var obj={id:'chaux'};
	var n;

	if(cfg_fusionUI)
	{
		const snd_xf=[75,75+135,75+135*2,75+135*3];

		obj.frame=gui.newFrame(frm, 0, 454+1, 640, 92, "img/svg/chopt_sends.svg");

		obj.icon=gui.newFrame(obj.frame, 640-10-21, 6, 21, 15, "img/svg/icon_aux_sends.svg");
		obj.label=gui.newLabel(obj.frame, 12, 5, 90, 16, '', {font:fontSemiBold(9), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		obj.label.setText("AUX Sends");

		obj.s=[];
		for(n=0; n<4; n++)
		{
			obj.s[n]=
			{
				onoff: gui.newLabel(obj.frame, snd_xf[n]-12, 46+4, 20, 14, '', {font:fontSemiBold(8), color:color.lyellow, align:gui.LEFT, valign:gui.TOP}),
				val:   gui.newLabel(obj.frame, snd_xf[n]+12-15, 46+18+2+2, 60, 14, '', {font:fontSemiBold(8), color:color.white, align:gui.CENTER}),
				mode:  gui.newLabel(obj.frame, snd_xf[n]+36, 46+4, 30, 14, '', {font:fontSemiBold(8), color:color.lyellow, align:gui.LEFT, valign:gui.TOP}),
				knob:  gui.newKnob (obj.frame, snd_xf[n]+12, 46, 20, 20, "img/svg/knob_aux.svg"),
				lblbg: gui.newFrame(obj.frame, snd_xf[n]+12+9-30+6, 31-3, 50, 14, "img/svg/send_title_bg.svg")
			};
			obj.s[n].label=gui.newLabel(obj.s[n].lblbg, 0, 0, 50, 14, '', {font:fontSemiBold(8), color:color.lblack, align:gui.CENTER, valign:gui.MIDDLE});
			obj.s[n].label.setText(host.sprintf("SEND %c", 65+n));
			obj.s[n].setOn=function(on) {this.onoff.setText(on?"ON":"OFF");}
		}
		obj.focus=function(on)
		{
			var bg=on?"img/svg/chopt_sends_sel.svg":"img/svg/chopt_sends.svg";

			this.frame.setBg(bg);
		};
	}
	else
	{
		const snd_x=[12,84,176,248];
		obj.frame=gui.newFrame(frm, 50, 376, 317, 67, "img/chopt_sends.png");
		obj.s=[];
		for(n=0; n<4; n++)
		{
			obj.s[n]=
			{
				onoff: gui.newPicture(obj.frame, snd_x[n]+ 0, 31, 17, 17, "img/led_onoff.png"),
				val:   gui.newLabel  (obj.frame, snd_x[n]+12, 15, 35, 14, '', prop.value),
				mode:  gui.newLabel  (obj.frame, snd_x[n]+40, 36, 25, 14, '', prop.value_left),
				knob:  gui.newKnob   (obj.frame, snd_x[n]+19, 32, 18, 18, "img/knob_18px.png")
			};
			obj.s[n].setOn=function(on) {this.onoff.setIndex(on?1:0);}
		}
		obj.focus=function(on)
		{
			var bg=on?"img/chopt_sends_sel.png":"img/chopt_sends.png";
			var pr=on?prop.ChoptFocused:prop.ChoptInactive;
			var idx=on?1:0;
			var n;

			this.frame.setBg(bg);
			for(n=0; n<4; n++)
			{
				this.s[n].onoff.setIndex(-1, idx);
				this.s[n].val.setProps(pr);
				this.s[n].mode.setProps(pr);
				this.s[n].knob.setIndex(idx);
			}
		};
	}

	obj.indi=function(msg)
	{
		if('bAUX1' in msg) this.s[0].setOn(msg.bAUX1==1);
		if('bAUX2' in msg) this.s[1].setOn(msg.bAUX2==1);
		if('bAUX3' in msg) this.s[2].setOn(msg.bAUX3==1);
		if('bAUX4' in msg) this.s[3].setOn(msg.bAUX4==1);
		if('bA1PF' in msg) this.s[0].mode.setText(msg.bA1PF==1?"POST":"PRE");
		if('bA2PF' in msg) this.s[1].mode.setText(msg.bA2PF==1?"POST":"PRE");
		if('bA3PF' in msg) this.s[2].mode.setText(msg.bA3PF==1?"POST":"PRE");
		if('bA4PF' in msg) this.s[3].mode.setText(msg.bA4PF==1?"POST":"PRE");
		if('wA1GN' in msg) knobSetValue(this.s[0], msg.wA1GN, aux_const);
		if('wA2GN' in msg) knobSetValue(this.s[1], msg.wA2GN, aux_const);
		if('wA3GN' in msg) knobSetValue(this.s[2], msg.wA3GN, aux_const);
		if('wA4GN' in msg) knobSetValue(this.s[3], msg.wA4GN, aux_const);
	};

	return obj;
}

/*
** choptNavigate
**
** navigate channel options
*/
function choptNavigate(d)
{
	var nf=this.focus;

	if(nf<0)
	{
		nf=-1;
		d=1;
	}

	if(d<0)
		while(nf-->0)
	{
		if(this.focuslist[nf]!=null) break;
	}
	else
		while(nf++<(this.focuslist.length-1))
	{
		if(this.focuslist[nf]!=null) break;
	}

	if((nf in this.focuslist) && this.focuslist[nf]!=null) this.setFocus(nf);
}

function choptKnobSetup()
{
	var chn=ch_data[this.channel];
	var pr={enabled:false, rot:null};

	switch(chn.knob_fn)
	{
	case knobFn.fatg:
		pr={enabled: !chn.gain_lock, rot:host.sprintf("Trim Gain\n%+.1f dB", chn.gain/10)};
		break;
	case knobFn.gain:
		if(chn.src_lwrp)
			pr={enabled:true, rot:host.sprintf("PreAmp Lvl\n%+.1f dB", chn.src_gain/10), angleNrm: (chn.src_gain+200)/1050};
		break;
	}
// Unload Request
	if(this.source.src_state==sstat.locked_elsewhere)
	{
		pr.enabled=true;
		pr.push="REQUEST\nUNLOAD";
	}
	else
		pr.push=null;

	sknobsSetTwo(1, 7, pr);
}

function choptKnobRot(delta)
{
	var chn=ch_data[this.channel];

	switch(chn.knob_fn)
	{
	case knobFn.fatg:
		if(!chn.gain_lock)
			host.sendChnCmsg(this.channel, {id:"WRIN", wFATG: valAdjust(chn.gain, delta, {min: -250, max: 250, step: 5, units: "dB"})});
		break;
	case knobFn.gain:
		if(chn.src_lwrp)
			host.lwctrlSetGain(chn.lpid, valAdjust(chn.src_gain, delta, {min: -200, max: 850, step: 5, units: "dB"}));
		break;
	}
}

function choptKnobGain(gain)
{
	var chn=ch_data[this.channel];

	if(chn.knob_fn==knobFn.gain && chn.src_lwrp)
		sknobsSetTwo(1, 7, {enabled:true, rot:host.sprintf("PreAmp Lvl\n%+.1f dB", gain/10), angleNrm: (gain+200)/1050});
}

function choptPageCreate()
{
	var p;
	var f;

	p=Page_Create('chopt', 'chopt', "");
	f=p.frame;

// 1. Current Source
	p.source=choptCreateSource(f);
	p.amix=choptCreateAutoMix(f);
// 2. Feed to Source (only for Codec & Phone)
	p.feed=choptCreateFeed(f);
// 3. Eq
	p.eq=choptCreateEq(f);
// 4. Pan & Mode
	p.pan=choptCreatePan(f);
// 5. Dynamics aka MicProcessing (only for Mics, Phone and Codec)
	p.micproc=choptCreateMicproc(f);
// 6. Aux Sends
	p.sends=choptCreateSends(f);

	p.focuslist=
	[
		p.source, p.amix, p.feed,
		p.eq,
		p.pan,    p.micproc,
		p.sends
	];
	p.focus=-1;
	p.knobUsed=false;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
	// remove focus
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(true);
	};
	p.enableOption=function(option, focuspos, enable)
	{
		if(enable)
		{
			option.frame.show();
			if(this.focus==focuspos) option.focus(true);
			this.focuslist[focuspos]=option;
		}
		else
		{
			option.frame.hide();
			if(this.focus==focuspos) this.setFocus(-1);
			this.focuslist[focuspos]=null;
		}
	};
	p.navigate=choptNavigate;

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "FUNCTION", push: "SELECT", jog: true, ltrt:true, enter: true, knob: true},
		{enabled: false},
		{enabled: false},
		{enabled: false},
		{enabled: false},
		{enabled: true, push: "EXIT"}
	];
	p.sknobs3=
	[
		{enabled: true, rot: "FUNCTION", push: "SELECT", jog: true, ltrt:true, enter: true, knob: true},
		{enabled: false},
		{enabled: true, push: "EXIT"}
	];

// event functions
	p.onOpen        =choptOnOpen;
	p.onClose       =choptOnClose;
	p.onIndi        =choptIndi;
	p.onSoftKnobRot =choptOnSoftKnobRot;
	p.onSoftKnobUp  =choptOnSoftKnobUp;

	p.onKnobRot     =function(){this.knobUsed=true;};
	p.onChoptUp     =function(){this.onSoftKnobUp((this.knobUsed && this.focus!=-1)?1:6);};

	p.choptKnobSetup=choptKnobSetup;
	p.choptKnobRot  =choptKnobRot;
	p.onGainChange  =choptKnobGain;

// Auxiliary Unload Request Page
	chsrcurPageCreate();
}

function choptOnOpen(channel_nr)
{
	if(channel_nr==null) return;
	this.channel=channel_nr;
// Indications
	this.title.setChannel(this.channel);
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 255);
	mod.setChnFusionInvert(this.channel, 1);
// Register receive msg handlers
	rxHandlersCh[this.channel].chopt=this;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

// update source sharing info: FIXME: it's a hack we need to read it just like any other parameters
	this.source.setSharingInfo(ch_data[this.channel].src_status, ch_data[this.channel].src_owner_name, ch_data[this.channel].src_owner_fader);

	this.knobUsed=false;
	this.choptKnobSetup();

// request meters
	chnRequestMeter(this.channel, mtrEng.chnSrc , mtrGUI.chopt_src , true);
	chnRequestMeter(this.channel, mtrEng.chnFeed, mtrGUI.chopt_feed, true);
	chnRequestMeter(this.channel, mtrEng.chnMic , mtrGUI.chopt_mic , true);

// request information for this channel
	var rmsg=host.sendChnCmsgRq(this.channel, {id:"READ",
		bSRCN:0, bSRCT:0, // source
		bAMEN:0, bAMWG:0, // automix
		bBFEN:0, bFSMO:0, bBFST:0, // Feed
		bEQHF:0, bEQMF:0, bEQLF:0, bEQHG:0, bEQMG:0, bEQLG:0, bEQAC:0, bEQHM:0, bEQLM:0, // eq
		bPANO:0, bMODE:0, bPHAS:0, bMLCK:0, // pan
		bA1GN:0, bA2GN:0, bA3GN:0, bA4GN:0,
		bAUX1:0, bAUX2:0, bAUX3:0, bAUX4:0,
		bA1PF:0, bA2PF:0, bA3PF:0, bA4PF:0, // aux
		bFATG:0, bFATL:0 // Fader Trim Gain
	});
	if(rmsg!=null) this.onIndi(rmsg);
}
function choptOnClose()
{
	sknobsHide();
// release meters
	chnRequestMeter(this.channel, mtrEng.chnSrc , mtrGUI.chopt_src , false);
	chnRequestMeter(this.channel, mtrEng.chnFeed, mtrGUI.chopt_feed, false);
	chnRequestMeter(this.channel, mtrEng.chnMic , mtrGUI.chopt_mic , false);
// delete receive msg handlers
	delete rxHandlersCh[this.channel].chopt;
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setChnFusionInvert(this.channel, 0);
}
function choptOnSoftKnobRot(idx, delta)
{
	var angle;

	if(idx==1 || idx==7)
	{
		this.navigate(delta);
		sknobsSetTwo(0, 6, {angleNrm: this.focus/(this.focuslist.length-1)});
	}
	if(idx==2 || idx==8)
		this.choptKnobRot(delta);
}
function choptOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 1:
	case 7:
		if(!(this.focus in this.focuslist)) return;
		var block=this.focuslist[this.focus];
		if(block==null) return;
		if(block.id in pages) chSwitchToPage(pages[block.id]);
		break;
	case 2:
	case 8:
		if(this.source.src_state==sstat.locked_elsewhere) chSwitchToPage(pages.chsrcur);
		break;
	case 6: // Normal 6
	case 9: // Combo 3
		closePage(this, this.channel);
		break;
	}
}
function choptIndi(chmsg)
{
	var pr;

// First Send to Options
	this.source.indi(chmsg);
	if(this.amix!=null) this.amix.indi(chmsg);
	this.feed.indi(chmsg);
	this.eq.indi(chmsg);
	this.pan.indi(chmsg);
	this.micproc.indi(chmsg);
	this.sends.indi(chmsg);

// Options Enable / Disable
	if('bBFEN' in chmsg) this.enableOption(this.feed, 2, chmsg.bBFEN);
	if('bSRCT' in chmsg) this.enableOption(this.micproc, 5, srcHasMicProc(chmsg.bSRCT));

	if(('bPRIM' in chmsg)
	|| ('bSRCS' in chmsg))
		this.choptKnobSetup();
	if(ch_data[this.channel].knob_fn==knobFn.fatg)
	{
		if('wFATG' in chmsg)
		{
			ch_data[this.channel].gain=chmsg.wFATG; // Update our stored value to avoid being out of sync. Most of the time this is just double assignment though
			pr=
			{
				rot: host.sprintf("Trim Gain\n%+.1f dB", chmsg.wFATG/10),
				angleNrm: (chmsg.wFATG+250)/500
			};

			sknobsSetTwo(1, 7, pr);
		}
		if('bFATL' in chmsg)
		{
			pr=
			{
				enabled: ((chmsg.bFATL==1) || (this.source.src_state==sstat.locked_elsewhere))
			};

			sknobsSetTwo(1, 7, pr);
		}
	}
}

// ------------------------ channel source unload request page ------------------------

function chsrcurPageCreate()
{
	var p;
	var f, list_fr;

	p=Page_Create('chsrcur', 'chn', "");
	f=p.frame;

	if(cfg_fusionUI)
	{
	// This part is identical to Source Select Page
		list_fr=gui.newFrame(f, 0, 40+3, 640, 504, "img/svg/ch_edit_src_bg.svg");
		gui.newFrame(list_fr, 640-20-20, 12, 20, 12, "img/svg/icon_source_list.svg");
		//we do not need to refer to these labels later on
		list_fr.srclabel=gui.newLabel(list_fr, 12, 12, 135, 16, '', {font:fontSemiBold(9), color:color.lgray, align:gui.RIGHT, valign:gui.MIDDLE});
		list_fr.srclabel.setText("CURRENT SOURCE:");
		list_fr.typelabel=gui.newLabel(list_fr, 12, 12+16+2, 135, 16, '', {font:fontSemiBold(9), color:color.lgray, align:gui.RIGHT, valign:gui.MIDDLE});
		list_fr.typelabel.setText("TYPE:");

		list_fr.statlabel=gui.newLabel(list_fr, 12, 12+(16+2)*2, 135, 16, '', {font:fontSemiBold(9), color:color.lgray, align:gui.RIGHT, valign:gui.MIDDLE});
		list_fr.statlabel.setText("STATUS:");

		list_fr.ownerlabel=gui.newLabel(list_fr, 12, 12+(16+2)*3, 135, 16, '', {font:fontSemiBold(9), color:color.lgray, align:gui.RIGHT, valign:gui.MIDDLE});
		list_fr.ownerlabel.setText("CURRENT OWNER:");

		p.cursrc_name=gui.newLabel(list_fr, 12+135+3, 12, 150, 16, '', {font:fontSemiBold(9), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
		p.cursrc_type=gui.newLabel(list_fr, 12+135+3, 12+16+2, 80, 16, '', {font:fontSemiBold(9), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
		p.cursrc_stat=gui.newLabel(list_fr, 12+135+3, 12+(16+2)*2, 180, 16, '', {font:fontSemiBold(9), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
		p.cursrc_owner=gui.newLabel(list_fr, 12+135+3, 12+(16+2)*3, 180, 16, '', {font:fontSemiBold(9), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});

		p.list=gui.newList(list_fr, 10, 95, 625, 42, '', prop.list);
	}
	else
	{
		list_fr=gui.newFrame(f, 32, 103, 353, 329, "img/ch_edit_src_bg.png");
		p.cursrc_type=gui.newLabel(list_fr, 125, 14,  50, 14, '', prop.value);
		p.cursrc_name=gui.newLabel(list_fr, 180, 10, 160, 19, '', prop.src);
		p.cursrc_stat=gui.newLabel(list_fr, 180, 30,  160, 14, '', prop.value);
		p.cursrc_owner=gui.newLabel(list_fr, 353/2-180/2, 50,  180, 14, '', prop.value);

		p.list=gui.newList(list_fr, 10, 85, 330, 32, '', prop.list);
		p.list.setProp('border', 1);
	}

	p.list.insert("Exit");
	p.list.insert("Request Source Unload");
	p.list.select(0);

	p.src_state=sstat.error;
	p.src_owner="";
	p.src_fader=0;

// softknobs
	p.sknobs6=
	[
		{enabled: true,  rot: "FUNCTION", push: "SELECT", list: p.list, updn: true, jog: true, enter: true, knob: true},
		{enabled: false},
		{enabled: false},
		{enabled: false},
		{enabled: false},
		{enabled: true, push: "EXIT"}
	];
	p.sknobs3=
	[
		{enabled: true, rot: "FUNCTION", push: "SELECT", list: p.list, updn: true, jog: true, enter: true, knob: true},
		{enabled: false},
		{enabled: true, push: "EXIT"}
	];

// event functions
	p.onOpen =chsrcurOnOpen;
	p.onClose=chsrcurOnClose;
	p.onIndi =chsrcurIndi;

	p.onSoftKnobUp=chsrcurOnSoftKnobUp;

// other functions
	p.updateSharingInfo=chsrcurUpdateSharingInfo;
	p.setSharingInfo=function(status, owner, fader)
	{
		this.src_state=status;
		this.src_owner=owner;
		this.src_fader=fader;
		this.updateSharingInfo();
	};
}

function chsrcurOnOpen(channel_nr)
{
	if(channel_nr==null) return;
	this.channel=channel_nr;
// Indications
	this.title.setChannel(this.channel);
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 255);
	mod.setChnFusionInvert(this.channel, 1);
// Register receive msg handlers
	rxHandlersCh[this.channel].chsrcown=this;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.list.select(0);

// update source sharing info: FIXME: it's a hack we need to read it just like any other parameters
	this.setSharingInfo(ch_data[this.channel].src_status, ch_data[this.channel].src_owner_name, ch_data[this.channel].src_owner_fader);

// request information for this channel
	var rmsg=host.sendChnCmsgRq(this.channel, {id:"READ",
		bSRCN:0, bSRCT:0 // source
	});
	if(rmsg!=null) this.onIndi(rmsg);
}

function chsrcurOnClose()
{
	sknobsHide();

// delete receive msg handlers
	delete rxHandlersCh[this.channel].chsrcown;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setChnFusionInvert(this.channel, 0);
}

function chsrcurIndi(msg)
{
	var update=false;
	var s="";
	if('bvSRCN' in msg) this.cursrc_name.setText(host.arrtostr(msg.bvSRCN));
	if( 'bSRCT' in msg) this.cursrc_type.setText(srct_txt[msg.bSRCT]);

	if('sSCON' in msg) {this.src_owner=msg.sSCON; update=true;}
	if('bSCFN' in msg) {this.src_fader=msg.bSCFN; update=true;}
	if('bSRCS' in msg) {this.src_state=msg.bSRCS; update=true;}
	if(update) this.updateSharingInfo();
}

function chsrcurUpdateSharingInfo()
{
	var status=null, owner="";
	switch(this.src_state)
	{
	case sstat.listenonly:
		status="LISTEN ONLY";
		owner=this.src_owner;
		if(this.src_fader>0) owner=(this.src_fader+": ")+owner;
		break;
	case sstat.full_control:
		status="FULL CONTROL";
		owner="THIS FADER";
		break;
	case sstat.full_control_no_bf:
		status="FULL CONTROL NO BF";
		owner="THIS FADER";
		break;
	case sstat.locked_elsewhere:
		status="LISTEN ONLY";
		owner=this.src_owner;
		if(this.src_fader>0) owner=(this.src_fader+": ")+owner;
		break;
	case sstat.listenonly_lock_err:
		status="LISTEN ONLY (LOCK ERROR)";
		owner=this.src_owner;
		if(this.src_fader>0) owner=(this.src_fader+": ")+owner;
		break;
	}
	if(status!=null)
	{
		this.cursrc_stat.setText(status);
		this.cursrc_owner.setText("Owner: "+owner);
	}
	else
	{
		this.cursrc_stat.setText("");
		this.cursrc_owner.setText("");
	}
}

function chsrcurOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 1: // select
	case 7:
		if(this.list.selection==0)
			chSwitchToPage(this); // will effectively go back to chopt page
		else if(this.list.selection==1)
		{
			chnRequestSourceUnload(this.channel);
			chSwitchToPage(this); // will effectively go back to chopt page
		}
		break;
	case 6:
	case 9: // Combo3
		chSwitchToPage(this); // will effectively go back to chopt page
		break;
	}
}
