// ------------------------ global sends page ------------------------

function sendsCreateObject(frame, x, y, title, tag)
{
	var obj={};

	if(cfg_fusionUI)
	{
		obj.on=gui.newLabel(frame, x+7, y+25+15+22+5, 50, 14, '', prop.value);
		obj.knob=gui.newKnob (frame, x+20, y+25+15, 22, 22, "img/svg/knob_22px.svg");
		obj.val =gui.newLabel(frame, x   , y+25, 60, 14, '', style.value);
		obj.label_bg=gui.newFrame(frame, x+7, y, 50, 14, "img/svg/send_title_bg.svg");
		obj.label=gui.newLabel(obj.label_bg, 0, 0, 50, 14, '', {font:fontSemiBold(8), color:color.lblack, align:gui.CENTER, valign:gui.MIDDLE});
		obj.setOn=function(on) {this.on.setText(on?"ON":"OFF");};
	}
	else
	{
		obj.on   =gui.newPicture(frame, x+21, y   , 20, 20, "img/on_off.png");
		obj.knob =gui.newKnob   (frame, x+20, y+40, 22, 22, "img/knob_22px.png");
		obj.val  =gui.newLabel  (frame, x   , y+25, 60, 14, '', prop.value);
		obj.label=gui.newLabel  (frame, x+ 2, y+63, 60, 14, '', prop.value);
		obj.setOn=function(on) {this.on.setIndex(on?1:0);};
	}

	obj.label.setText(title);
	obj.tag=tag;
	obj.preview=false;
	obj.onsw=false;
	obj.msgn=0;

	return obj;
}

function sendsPageCreate()
{
	var p;
	var aux_fr;

	p=Page_Create('sends', 'mon', "SENDS");

	if(cfg_fusionUI)
	{
		aux_fr=gui.newFrame(p.frame, 0, 6+27+10, 640, 240, "img/svg/aux_sends_bg_lrg.svg");
		aux_fr.title=gui.newLabel  (aux_fr, 10, 10, 228, 16, '', prop.value_left_medium);
		aux_fr.title.setText("AUX SEND MASTERS");
		gui.newFrame(aux_fr, 640-10-21, 12, 21, 15, "img/svg/icon_aux_sends.svg");

		const x=95;
		const dx=125;
		const y=20;

		p.sends=[];
		p.sends[0]=sendsCreateObject(aux_fr, x, 37+y, "SEND A", 'mSND1');
		p.sends[1]=sendsCreateObject(aux_fr, x+dx*1, 37+y, "SEND B", 'mSND2');
		p.sends[2]=sendsCreateObject(aux_fr, x+dx*2, 37+y, "SEND C", 'mSND3');
		p.sends[3]=sendsCreateObject(aux_fr, x+dx*3, 37+y, "SEND D", 'mSND4');

	// indicates which channel will be controlled with preview knob
		p.preview=gui.newFrame(aux_fr, 81, 140, 90, 39, '');
		p.preview.line =gui.newPicture(p.preview, 90/2-1,  0,  2, 22, "img/svg/line_vert_22px.svg");
		p.preview.label=gui.newLabel  (p.preview,  0, 24, 90, 14, '', prop.value);
		p.updatePreview=function()
		{
			this.preview.moveTo(81+this.prv_select*125, 140);
			this.preview.label.setText(this.sends[this.prv_select].preview?"PREVIEW ON":"PREVIEW OFF");
		};
	}
	else
	{
		aux_fr=gui.newFrame(p.frame, 32, 103, 353, 169, "img/mst_sends_bg.png");

		p.sends=[];
		p.sends[0]=sendsCreateObject(aux_fr,  13, 37, "SEND A", 'mSND1');
		p.sends[1]=sendsCreateObject(aux_fr,  90, 37, "SEND B", 'mSND2');
		p.sends[2]=sendsCreateObject(aux_fr, 163, 37, "SEND C", 'mSND3');
		p.sends[3]=sendsCreateObject(aux_fr, 240, 37, "SEND D", 'mSND4');

	// indicates which channel will be controlled with preview knob
		p.preview=gui.newFrame(aux_fr, 15, 118, 60, 39, '');
		p.preview.line =gui.newPicture(p.preview, 29,  0,  2, 22, "img/line_vert.png");
		p.preview.label=gui.newLabel  (p.preview,  0, 24, 60, 14, '', prop.value);
		p.updatePreview=function()
		{
			const xpos=[15,92,165,242];

			this.preview.moveTo(xpos[this.prv_select], 118);
			this.preview.label.setText(p.sends[this.prv_select].preview?"PREVIEW ON":"PREVIEW OFF");
			sknobsSetOne(5, {angleNrm:this.prv_select/3});
		};
	}
	p.prv_select=0;
	p.updatePreview();

	p.sknobs6=
	[
		{enabled: true, rot: "SEND A", push: "OFF"},
		{enabled: true, rot: "SEND B", push: "OFF"},
		{enabled: true, rot: "SEND C", push: "OFF"},
		{enabled: true, rot: "SEND D", push: "OFF"},
		{enabled: false},
		{enabled: true, rot: "SELECT", push: "PREVIEW"}
	];

// event functions
	p.onOpen =sendsOnOpen;
	p.onClose=sendsOnClose;
	p.onSoftKnobRot =sendsOnSoftKnobRot;
	p.onSoftKnobDown=sendsOnSoftKnobDown;
	p.onSoftKnobUp  =sendsOnSoftKnobUp;
}
function sendsOnOpen(channel_nr)
{
	var rmsg, read_msg={id:"READ", bMSGN:0, bONSW:0, bPREV:0};

// Indications
	mod.setMasterKeyLed(keys.MstSendRet, 255);

	sknobsShow(this.sknobs6);

// register receive msg handlers
	rxHandlersGlobal.sendsIndi=sendsIndi;

	rmsg=host.sendCmsgRq({id:"NEST", mSND1:read_msg, mSND2:read_msg, mSND3:read_msg, mSND4:read_msg});
	if(rmsg!=null) sendsIndi(rmsg);
}
function sendsOnClose()
{
// turn preview off if it is ON
	if(this.sends[this.prv_select].preview) host.sendNestCmsg(this.sends[this.prv_select].tag, {id:'WRIN', bPREV:0});
	sknobsHide();
// delete receive msg handlers
	delete rxHandlersGlobal.sendsIndi;
	mod.setMasterKeyLed(keys.MstSendRet, 0);
}
function sendsIndi(msg)
{
	var p=pages.sends;
	var n, obj;

	for(n=0; n<4; n++)
	{
		obj=p.sends[n];
		if(obj.tag in msg)
			sendsIndiEx(msg[obj.tag], p, obj, n);
	}
}
function sendsIndiEx(submsg, page, bus_obj, soft_knob_idx)
{
	var angl;

	if('wMSGN' in submsg)
	{
		bus_obj.msgn=submsg.wMSGN;
		angl=knobSetValue(bus_obj, bus_obj.msgn, aux_const);
		sknobsSetOne(soft_knob_idx, {angleNrm:angl});
	}
	if('bONSW' in submsg)
	{
		bus_obj.onsw=submsg.bONSW!=0;
		bus_obj.setOn(bus_obj.onsw);
		sknobsSetOne(soft_knob_idx, {push:bus_obj.onsw?"ON":"OFF"});
	}
	if('bPREV' in submsg)
	{
		bus_obj.preview=submsg.bPREV!=0;
		page.updatePreview();
	}
}
function sendsOnSoftKnobRot(idx, delta)
{
	switch (idx){
	case 1:
	case 2:
	case 3:
	case 4:
		sendsSetGain(this.sends[idx-1].tag, this.sends[idx-1].msgn, delta);
		break;
	case 6:
		if(delta==0) break;
		if(this.sends[this.prv_select].preview) break; // Preview is on, don't allow to navigate from it
		this.prv_select=clamp(this.prv_select+(delta>0?1:-1), 0, 3);
		this.updatePreview();
		break;
	}
}
function sendsOnSoftKnobDown(idx)
{
	switch(idx)
	{
	case 1:
	case 2:
	case 3:
	case 4:
		toggleVal(this.sends[idx-1].tag, 'bONSW', this.sends[idx-1].onsw);
		break;
	case 6:
		host.sendNestCmsg(this.sends[this.prv_select].tag, {id:'WRIN', bPREV:1});
		break;
	}
}
function sendsOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 6:
		host.sendNestCmsg(this.sends[this.prv_select].tag, {id:'WRIN', bPREV:0});
		break;
	}
}
function sendsSetGain(tag, oldval, delta)
{
	var newgain=clamp(oldval+(delta*aux_const.step), aux_const.min, aux_const.max);

	host.sendNestCmsg(tag, {id:"WRIN", wMSGN:newgain});
}
