
function widget_input(srv, name, value, size, td)
{
	if(td) srv.putstr("<td>");
	srv.putstr("<input type='text' name='"+name+"' value='"+value+"' size='"+size+"'>");
	if(td) srv.putstr("</td>");
}

function dasm_IP(ip)
{
	return String(ip&0xFF) +"."+ String((ip>> 8)&0xFF) +"."+ String((ip>>16)&0xFF) +"."+ String((ip>>24)&0xFF);
}

function asm_IP(ip)
{
	return ip[0]|(ip[1]<<8)|(ip[2]<<16)|(ip[3]<<24);
}

function checkIP(ipaddr)
{
	var re = /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/;
	if (re.test(ipaddr))
	{
		var parts = ipaddr.split(".");
		for (var i=0; i<parts.length; i++)
		{
			parts[i]=parseInt(parts[i]);
			if(parts[i]>255) return false;
		}
		return parts;
	}
	else
	{
		return false;
	}
}

function engine_request(srv)
{
	var engine_ip;
	var rmsg;
	var surround;

	if(srv.findVar("msg")=='1') print_error_msg(srv, "Error occurred! New settings could not be saved!");

	srv.putstr("<h2>Engine Settings</h2>");

	rmsg=host.sendNestCmsgRq('mCONF', {id:'READ', bENGA:0});
	if(rmsg==null || !('dENGA' in rmsg))
		srv.putstr("<div class='box_err'>Unable to retrieve Engine settings</div>");
	else
	{
		engine_ip=dasm_IP(rmsg.dENGA);
		surround=host.cfgGetString('scr.surroundMode', 'no')=='yes';
		if(cfg_surroundMode!=surround)
			srv.putstr("<div class='box_inf'>You need a <a href='/reboot'>reboot</a> to apply new surround mode settings</div>");

		srv.putstr("<form method='post' action='/usr/engine_apply'><table>");
		srv.putstr("<tr><td>Engine IP:</td>");
			widget_input(srv, "engine_ip", engine_ip, 16, true);
		srv.putstr("</tr>");
		srv.putstr("<tr><td>Console Mode:</td><td><select name='surround'>");
			srv.printf("<option value='no' %s>Stereo</option>", surround?"":"selected");
			srv.printf("<option value='yes' %s>Surround</option>", surround?"selected":"");
		srv.putstr("</select></tr>");
		srv.putstr("<tr><td colspan='2' align=right><input type='submit' name='save_changes' value='Save'></td></tr>");
		srv.putstr("</table></form>");
	}

	srv.finalize();
}

function engine_request_apply(srv)
{
	var checked_ip=checkIP(srv.findVar("engine_ip"));
	if(checked_ip!==false)
		host.sendNestCmsg('mCONF', {id:'WRIN', dENGA:asm_IP(checked_ip)});

	var surround=srv.findVar("surround");
	if(surround!=null)
		host.cfgSetString('scr.surroundMode', (surround=="yes")?'yes':'no');

	srv.redirect("/usr/engine");
	srv.finalize();
}

host.httpRegister("engine", 'engine_request', true, true);
host.httpRegister("engine_apply", 'engine_request_apply', false, true);
host.httpAddLink("/usr/engine", "Misc.", "Engine", 1002);

function print_error_msg(srv, msg)
{
// print err.msg.
	srv.putstr("<span style='color:red;font-weight:bold;'>"+msg+"</span>");
}
